var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-155F91D0-D3C9-4D54-BFB6-D3DEFDADC40C\">\n\
      <meta name=\"indexterm\" content=\"writing a plug-in\">\n\
      <meta name=\"indexterm\" content=\"plug-ins: writing\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Writing a simple plug-in</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-155F91D0-D3C9-4D54-BFB6-D3DEFDADC40C\"></a><div class=\"head\">\n\
            <h1>Writing a simple plug-in</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F1425\"></a>The following provides information on how to write a simple plug-in called Hello World.\n\
            \n\
            	 \n\
         </p>\n\
         <div class=\"section\"><a name=\"WS17956D7ADBC6E736-3269E342117AE332002-7FFD\"></a> \n\
            <h2><a name=\"GUID-88454886-19DB-40F5-BF48-A9D5EDE1DE98\"></a>Writing your first plug-in\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F1426\"></a> When learning a new computer language, the first program you are likely to see is\n\
               a \"Hello World\" program. Following this tradition, the first plug-in we create is\n\
               a \"Hello World\" plug-in, which simply outputs \"Hello World\" to the window from which\n\
               Maya was launched. \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
#include &lt;maya/MSimple.h&gt;\n\
#include &lt;maya/MIOStream.h&gt;\n\
<a href=\"javascript:void(0)\" data-symbol=\"DeclareSimpleCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gaf3b44fe07495c3792b926494fca7b517&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">DeclareSimpleCommand</a>( helloWorld, \"Autodesk\", \"2017\");\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helloWorld::doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgList</a>&amp; )\n\
{\n\
    cout &lt;&lt; \"Hello World\\n\" &lt;&lt; endl;\n\
    return MS::kSuccess;\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F1428\"></a>Linux 64-bit: \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F1429\"></a>If this is put into a file called \n\
               		  <span class=\"code\" translate=\"no\">helloWorld.cpp</span> it can be compiled with: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
g++412 -c -I. -I.. -I/usr/autodesk/maya2017/include -I/usr/X11R6/include -m64 -O3 -pthread -pipe -D_BOOL -DLINUX_64 -DREQUIRE_IOSTREAM -fPIC -mtune=pentium4 -Wno-deprecated -fno-gnu-keywords helloCmd.cpp\n\
g++412 -shared -m64 -O3 -pthread -pipe -D_BOOL -DLINUX -DREQUIRE_IOSTREAM -mtune=pentium4 -Wno-deprecated -fno-gnu-keywords -Wl,-Bsymbolic -shared -o helloCmd.so helloCmd.o -L/usr/autodesk/maya2017-x64/lib -lOpenMaya -lFoundation\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F142A\"></a>Windows and Mac OS X: \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F142B\"></a>If this is put into a file called \n\
               		  <span class=\"code\" translate=\"no\">helloWorld.cpp</span>, it can be compiled by following the platform-specific instructions in \n\
               		  <span class=\"char_link\"><a href=\"#!/url=./files/Setting_up_your_build_env_Windows_env_32bit_and_64bit.htm#WS17956D7ADBC6E7366D5C9783117AE330779-7FF7\">Creating your own plug-in build file</a></span> for the \n\
               		  <span class=\"char_link\"><a href=\"#!/url=./files/Setting_up_your_build_env_Windows_env_32bit_and_64bit.htm\">Windows environment \n\
                     		  </a></span> and \n\
               		  <span class=\"char_link\"><a href=\"#!/url=./files/Setting_up_your_build_environment_Mac_OS_X_environment.htm\">Mac OS X environment</a></span>. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F142C\"></a>Once the file has compiled, you can load it into Maya (see \n\
               		  <span class=\"char_link\"><a href=\"#!/url=./files/API_Loading_a_Plugin.htm\">Loading a Plug-in</a></span>). Type \"helloWorld\" into the command window (press Enter to invoke the command),\n\
               and \"Hello World\" displays in the output window. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";