var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-753B04D0-795C-4341-A597-7E947ECBA4DF\">\n\
      <meta name=\"indexterm\" content=\"MPxToolCommand\">\n\
      <meta name=\"indexterm\" content=\"finalize()\">\n\
      <meta name=\"indexterm\" content=\"command: output to journal file\">\n\
      <meta name=\"indexterm\" content=\"MPxToolCommand: doFinalize()\">\n\
      <meta name=\"indexterm\" content=\"finalize()\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>MPxToolCommand</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-753B04D0-795C-4341-A597-7E947ECBA4DF\"></a><div class=\"head\">\n\
            <h1>MPxToolCommand</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA73\"></a> The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxToolCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_tool_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxToolCommand</a></span> is the base class for creating commands that can be executed from within a context.\n\
            Tool commands are similar to regular commands in that they are defined with command\n\
            flags and can be executed from the Maya command line. However, they must perform extra\n\
            duties, as the actions taken by a context do not come from the normal Maya command\n\
            mechanism but from inside the methods of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxContext</a></span> class. These duties are to alert Maya of the execution of the command so that the\n\
            undo/redo and journalling mechanisms operate correctly on the command. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxToolCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_tool_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxToolCommand</a></span> is a subclass of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCommand</a></span> with the additional methods. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA75\"></a>If a context wants to perform its own command, it must register the command when the\n\
            context and context command are registered. A context can only have one tool command\n\
            associated with it. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA76\"></a>The following is an example of a tool command, the helixTool. As with the marqueeTool,\n\
            the list of include files is omitted for brevity. See the helixTool.cpp file in the\n\
            Developer Kit for the complete example. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
#define NUMBER_OF_CVS 20\n\
class helixTool : public <a href=\"javascript:void(0)\" data-symbol=\"MPxToolCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_tool_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxToolCommand</a>\n\
{\n\
    public:\n\
        helixTool(); \n\
        virtual ~helixTool(); \n\
        static void* creator();\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgList</a>&amp; args );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> redoIt();\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> undoIt();\n\
        bool isUndoable() const;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> finalize();\n\
        static <a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a> newSyntax();\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA77\"></a> The set of methods on <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxToolCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_tool_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxToolCommand</a></span> are similar to those on <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCommand</a></span> but with the addition of <span class=\"code\" translate=\"no\">finalize()</span>. The finalize method is used to create a string representing the command and its\n\
            arguments. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
        void setRadius( double newRadius );\n\
        void setPitch( double newPitch );\n\
        void setNumCVs( unsigned newNumCVs );\n\
        void setUpsideDown( bool newUpsideDown );\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA79\"></a>These methods are necessary since the properties of the helix will be set from the\n\
            context object. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
    private:\n\
        double radius; // Helix radius\n\
        double pitch; // Helix pitch\n\
        unsigned numCV; // Helix number of CVs\n\
        bool upDown; // Helis upsideDown\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath</a> path; // Dag path to the curve.\n\
        // Don’t save the pointer!\n\
};\n\
void* helixTool::creator()\n\
{\n\
    return new helixTool;\n\
}\n\
helixTool::~helixTool() {}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA7A\"></a>These first two methods are identical to the earlier \"helix2\" example. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
helixTool::helixTool()\n\
{ \n\
    numCV = NUMBER_OF_CVS;\n\
    upDown = false;\n\
    setCommandString( \"helixToolCmd\" );\n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA7B\"></a>The constructor saves away the name of the MEL command for later use in the <span class=\"code\" translate=\"no\">finalize()</span> method. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a> helixTool::newSyntax()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a> syntax;\n\
    syntax.addFlag(kPitchFlag, kPitchFlagLong,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MSyntax::kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html#ae6f2057f0d0419845a48c1eb6813f2adacd70f5d2b5e8c1bb8e83b0482a33e518&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax::kDouble</a>);\n\
    syntax.addFlag(kRadiusFlag, kRadiusFlagLong,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MSyntax::kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html#ae6f2057f0d0419845a48c1eb6813f2adacd70f5d2b5e8c1bb8e83b0482a33e518&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax::kDouble</a>);\n\
    syntax.addFlag(kNumberCVsFlag, kNumberCVsFlagLong,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MSyntax::kUnsigned\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html#ae6f2057f0d0419845a48c1eb6813f2ada499591c04ccb62ab4f6fc3a5450afd4c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax::kUnsigned</a>);\n\
    syntax.addFlag(kUpsideDownFlag, kUpsideDownFlagLong,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MSyntax::kBoolean\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html#ae6f2057f0d0419845a48c1eb6813f2ada8cfc0ab572a96edfc9db7c02f0d025d7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax::kBoolean</a>);\n\
    return syntax;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixTool::doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgList</a> &amp;args )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> status;\n\
    status = parseArgs(args);\n\
    if (MS::kSuccess != status)\n\
        return status;\n\
    return redoIt();\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixTool::parseArgs(const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgList</a> &amp;args)\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> status;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MArgDatabase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_database.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_database.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgDatabase</a> argData(syntax(), args);\n\
    if (argData.isFlagSet(kPitchFlag)) {\n\
        double tmp;\n\
        status = argData.getFlagArgument(kPitchFlag, 0, tmp);\n\
        if (!status) {\n\
            status.perror(\"pitch flag parsing failed.\");\n\
            return status;\n\
        }\n\
        pitch = tmp;\n\
    }\n\
    if (argData.isFlagSet(kRadiusFlag)) {\n\
        double tmp;\n\
        status = argData.getFlagArgument(kRadiusFlag, 0, tmp);\n\
        if (!status) {\n\
            status.perror(\"radius flag parsing failed.\");\n\
            return status;\n\
        }\n\
        radius = tmp;\n\
    }\n\
    if (argData.isFlagSet(kNumberCVsFlag)) {\n\
        unsigned tmp;\n\
        status = argData.getFlagArgument(kNumberCVsFlag,\n\
            0, tmp);\n\
        if (!status) {\n\
            status.perror(\"numCVs flag parsing failed.\");\n\
            return status;\n\
        }\n\
        numCV = tmp;\n\
    }\n\
    if (argData.isFlagSet(kUpsideDownFlag)) {\n\
        bool tmp;\n\
        status = argData.getFlagArgument(kUpsideDownFlag,\n\
            0, tmp);\n\
        if (!status) {\n\
            status.perror(\"upside down flag parsing failed.\");\n\
            return status;\n\
        }\n\
        upDown = tmp;\n\
    }\n\
    return MS::kSuccess;\n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA7C\"></a>This method is similar to the earlier helix example—it parses the arguments and uses\n\
            them to set its internal state. In general, this command will be used through the\n\
            UI, but since it is still a MEL command, it can be invoked from the MEL command shell.\n\
            \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixTool::redoIt()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> stat;\n\
    const unsigned deg = 3; // Curve Degree\n\
    const unsigned ncvs = NUMBER_OF_CVS;// Number of CVs\n\
    const unsigned spans = ncvs - deg; // Number of spans\n\
    const unsigned nknots = spans+2*deg-1;// Number of knots\n\
    unsigned i;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPointArray</a> controlVertices;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_double_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDoubleArray</a> knotSequences;\n\
    int upFactor;\n\
    if (upDown) upFactor = -1;\n\
    else upFactor = 1;\n\
    // Set up cvs and knots for the helix\n\
    //\n\
    for (i = 0; i &lt; ncvs; i++)\n\
        controlVertices.append( <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPoint</a>(\n\
        radius * cos( (double)i ),\n\
        upFactor * pitch * (double)i,\n\
        radius * sin( (double)i ) ) );\n\
    for (i = 0; i &lt; nknots; i++)\n\
        knotSequences.append( (double)i );\n\
    // Now create the curve\n\
    //\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnNurbsCurve\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_nurbs_curve.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNurbsCurve</a> curveFn;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> curve = curveFn.create( controlVertices,\n\
        knotSequences, deg, <a href=\"javascript:void(0)\" data-symbol=\"MFnNurbsCurve::kOpen\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_nurbs_curve.html#a99f5203c7742378941e34926280c8e66a7fb3bf49ba349ca1a266be41df447b5b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNurbsCurve::kOpen</a>,\n\
        false, false, <a href=\"javascript:void(0)\" data-symbol=\"MObject::kNullObj\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html#ae6af14e0aa2c92bdda88c81280e1d122&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject::kNullObj</a>, &amp;stat );\n\
    if ( !stat )\n\
    {\n\
        stat.perror(\"Error creating curve\");\n\
        return stat;\n\
    }\n\
    stat = curveFn.getPath( path );\n\
    return stat;\n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA7D\"></a>This is essentially the same as the earlier helix example. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixTool::undoIt()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> stat; \n\
    <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> transform = path.transform();\n\
    stat = <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::removeFromModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#acccac5ce696c5ab724ff96947f46c41b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGlobal::removeFromModel</a>( transform );\n\
    return stat;\n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA7E\"></a>Again this is essentially the same as the earlier helix example. You should be noticing\n\
            a pattern developing. It is quite easy to change a command into a tool. Little of\n\
            the command has to be changed, additions just have to be made to hook the tool up\n\
            to the UI. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
bool helixTool::isUndoable() const\n\
{\n\
    return true; \n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA7F\"></a>This tool is undoable. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixTool::finalize()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgList</a> command;\n\
    command.addArg( commandString() );\n\
    command.addArg( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a>(kRadiusFlag) );\n\
    command.addArg( radius );\n\
    command.addArg( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a>(kPitchFlag) );\n\
    command.addArg( pitch );\n\
    command.addArg( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a>(kNumberCVsFlag) );\n\
    command.addArg( (int)numCV );\n\
    command.addArg( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a>(kUpsideDownFlag) );\n\
    command.addArg( upDown );\n\
    return <a href=\"javascript:void(0)\" data-symbol=\"MPxToolCommand::doFinalize\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_tool_command.html#a453a8fb7a2285d97888cf2a60fa64712&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxToolCommand::doFinalize</a>( command );\n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA80\"></a>   This method is the one noticeable addition to the tool which wasn’t necessary in the\n\
            command. When a command is typed in it is easy to take it and print it out to a journal\n\
            file. Since a tool is not typed in, but created through mouse input, no text string\n\
            exists to be output to a journal file. The <span class=\"code\" translate=\"no\">finalize()</span> method solves this by outputting a string when the tool has completed. It is necessary\n\
            for you to call <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxToolCommand::doFinalize()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_tool_command.html#a453a8fb7a2285d97888cf2a60fa64712&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxToolCommand::doFinalize()</a></span> to have the command output to the journal file. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
void helixTool::setRadius( double newRadius )\n\
{\n\
    radius = newRadius;\n\
}\n\
void helixTool::setPitch( double newPitch )\n\
{\n\
    pitch = newPitch;\n\
}\n\
void helixTool::setNumCVs( unsigned newNumCVs )\n\
{\n\
    numCV = newNumCVs;\n\
}\n\
void helixTool::setUpsideDown( double newUpsideDown )\n\
{\n\
    upDown = newUpsideDown;\n\
}\n\
const char helpString[] = \"Click and drag to draw helix\";\n\
class helixContext : public <a href=\"javascript:void(0)\" data-symbol=\"MPxContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxContext</a>\n\
{\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA84\"></a>This is the context which will be executing the helixTool command. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
    public:\n\
        helixContext();\n\
        virtual void toolOnSetup( <a href=\"javascript:void(0)\" data-symbol=\"MEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvent</a> &amp; event );\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> doPress( <a href=\"javascript:void(0)\" data-symbol=\"MEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvent</a> &amp; event );\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> doDrag( <a href=\"javascript:void(0)\" data-symbol=\"MEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvent</a> &amp; event );\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> doRelease( <a href=\"javascript:void(0)\" data-symbol=\"MEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvent</a> &amp; event );\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> doEnterRegion( <a href=\"javascript:void(0)\" data-symbol=\"MEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvent</a> &amp; event );\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA85\"></a>The set of methods are the same as for the marqueeTool example. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
    private:\n\
        short startPos_x, startPos_y;\n\
        short endPos_x, endPos_y;\n\
        unsigned numCV;\n\
        bool upDown;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"M3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m3d_view.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">M3dView</a> view;\n\
        GLdouble height,radius;\n\
};\n\
helixContext::helixContext() \n\
{\n\
    setTitleString( \"Helix Tool\" );\n\
}\n\
void helixContext::toolOnSetup( <a href=\"javascript:void(0)\" data-symbol=\"MEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvent</a> &amp; )\n\
{\n\
    setHelpString( helpString );\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixContext::doPress( <a href=\"javascript:void(0)\" data-symbol=\"MEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvent</a> &amp; event )\n\
{\n\
    event.getPosition( startPos_x, startPos_y );\n\
    view = MGlobal::active3dView();\n\
    view.beginGL();\n\
    view.beginOverlayDrawing();\n\
    return MS::kSuccess;\n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA86\"></a>These three methods are essentially the same as the marqueeTool examples, the only\n\
            difference being that <span class=\"code\" translate=\"no\">doPress()</span> for the helixTool does not need to determine the modifier key state. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixContext::doDrag( <a href=\"javascript:void(0)\" data-symbol=\"MEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvent</a> &amp; event )\n\
{\n\
    event.getPosition( endPos_x, endPos_y );\n\
    view.clearOverlayPlane();\n\
    glIndexi( 2 );\n\
    int upFactor;\n\
    if (upDown) upFactor = 1;\n\
    else upFactor = -1;\n\
    // Draw the guide cylinder\n\
    //\n\
    glMatrixMode( GL_MODELVIEW );\n\
    glPushMatrix();\n\
    glRotatef( upFactor * 90.0, 1.0f, 0.0f, 0.0f );\n\
    GLUquadricObj *qobj = gluNewQuadric();\n\
    gluQuadricDrawStyle(qobj, GLU_LINE);\n\
    GLdouble factor = (GLdouble)numCV;\n\
    radius = fabs(endPos_x - startPos_x)/factor + 0.1;\n\
    height = fabs(endPos_y - startPos_y)/factor + 0.1;\n\
    gluCylinder( qobj, radius, radius, height, 8, 1 );\n\
    glPopMatrix();\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA87\"></a>This code draws a cylinder in the current view defining the outlines of the helix\n\
            that will be generated. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
#ifndef _WIN32\n\
    glXSwapBuffers(view.display(), view.window() );\n\
#else\n\
    SwapBuffers(view.deviceContext() );\n\
#endif\n\
    return MS::kSuccess;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixContext::doRelease( <a href=\"javascript:void(0)\" data-symbol=\"MEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvent</a> &amp; )\n\
{\n\
    // Clear the overlay plane &amp; restore from overlay drawing\n\
    //\n\
    view.clearOverlayPlane();\n\
    view.endOverlayDrawing();\n\
    view.endGL();\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA88\"></a>The user has released the mouse so this code cleans up the OpenGL drawing. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
    helixTool * cmd = (helixTool*)newToolCommand();\n\
    cmd-&gt;setPitch( height/NumCVs );\n\
    cmd-&gt;setRadius( radius );\n\
    cmd-&gt;setNumCVs( numCV );\n\
    cmd-&gt;setUpsideDown( upDown );\n\
    cmd-&gt;redoIt();\n\
    cmd-&gt;finalize();\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA89\"></a>This code creates the actual helixTool command, by calling the helixTool::creator\n\
            method that you will register later, sets the radius and pitch, and then calls the\n\
            <span class=\"code\" translate=\"no\">redoIt()</span> method to generate the data. As a last step, the <span class=\"code\" translate=\"no\">finalize()</span> method is called to ensure that this command is written out to the journal file.\n\
            \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
    return MS::kSuccess;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixContext::doEnterRegion( <a href=\"javascript:void(0)\" data-symbol=\"MEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvent</a> &amp; )\n\
{\n\
    return setHelpString( helpString );\n\
}\n\
void helixContext::getClassName( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> &amp;name ) const\n\
{\n\
    name.set(\"helix\");\n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA8A\"></a>The next four methods are used in the interaction between the context and the contextCommand’s\n\
            edit and query methods. These will be called by the tool property sheet for the context.\n\
            The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MToolsInfo::setDirtyFlag()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_tools_info.html#afc06e5e83a38fd464a506b4ec70c0b25&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MToolsInfo::setDirtyFlag()</a></span> method alerts the tool property sheet so it can redraw itself with the new property\n\
            values for the context. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
void helixContext::setNumCVs( unsigned newNumCVs )\n\
{\n\
    numCV = newNumCVs;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MToolsInfo::setDirtyFlag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_tools_info.html#afc06e5e83a38fd464a506b4ec70c0b25&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MToolsInfo::setDirtyFlag</a>(*this);\n\
}\n\
void helixContext::setUpsideDown( bool newUpsideDown )\n\
{\n\
    upDown = newUpsideDown;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MToolsInfo::setDirtyFlag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_tools_info.html#afc06e5e83a38fd464a506b4ec70c0b25&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MToolsInfo::setDirtyFlag</a>(*this);\n\
}\n\
unsigned helixContext::numCVs()\n\
{\n\
    return numCV;\n\
}\n\
bool helixContext::upsideDown()\n\
{\n\
    return upDown;\n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA8B\"></a>The next class and implementation repeats the code from the marqueeTool example. This\n\
            class is necessary to create instances of the tool context. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
class helixContextCmd : public <a href=\"javascript:void(0)\" data-symbol=\"MPxContextCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_context_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxContextCommand</a>\n\
{\n\
    public: \n\
        helixContextCmd();\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> doEditFlags();\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> doQueryFlags();\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MPxContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxContext</a>* makeObj();\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> appendSyntax();\n\
        static void* creator();\n\
    protected:\n\
        helixContext * fHelixContext;\n\
};\n\
helixContextCmd::helixContextCmd() {}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MPxContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxContext</a>* helixContextCmd::makeObj()\n\
{\n\
    fHelixContext = new helixContext();\n\
    return fHelixContext;\n\
}\n\
void* helixContextCmd::creator()\n\
{\n\
    return new helixContextCmd;\n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA8C\"></a>The next two methods handle the argument parsing for the command. There are two types\n\
            of arguments—those which make modifications to the properties of a context, and those\n\
            which query the properties of a context. \n\
         </p>\n\
         <div><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA8D\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n\
               <p><a name=\"GUID-90F1DC31-546B-4E02-B75C-82ED11CDBC1E\"></a>Argument parsing is done through the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxContextCommand::parser()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_context_command.html#aa367dd5b853c97af707d0fb44aa37971&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxContextCommand::parser()</a></span> method which returns an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a></span>. This class is analogous to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgDatabase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_database.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_database.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgDatabase</a></span> class that is used with the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCommand</a></span> class. \n\
               </p> \n\
            </div>\n\
         </div>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixContextCmd::doEditFlags()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> argData = parser();\n\
    if (argData.isFlagSet(kNumberCVsFlag)) {\n\
        unsigned numCVs;\n\
        status = argData.getFlagArgument(kNumberCVsFlag,\n\
            0, numCVs);\n\
        if (!status) {\n\
            status.perror(\"numCVs flag parsing failed.\");\n\
            return status;\n\
        }\n\
        fHelixContext-&gt;setNumCVs(numCVs);\n\
    }\n\
    if (argData.isFlagSet(kUpsideDownFlag)) {\n\
        bool upsideDown;\n\
        status = argData.getFlagArgument(kUpsideDownFlag,\n\
            0, upsideDown);\n\
        if (!status) {\n\
            status.perror(\"upsideDown flag parsing failed.\");\n\
            return status;\n\
        }\n\
        fHelixContext-&gt;setUpsideDown(upsideDown);\n\
    }\n\
\n\
    return MS::kSuccess;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixContextCmd::doQueryFlags()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> argData = parser();\n\
    if (argData.isFlagSet(kNumberCVsFlag)) {\n\
        setResult((int) fHelixContext-&gt;numCVs());\n\
    }\n\
    if (argData.isFlagSet(kUpsideDownFlag)) {\n\
        setResult(fHelixContext-&gt;upsideDown());\n\
    }\n\
    return MS::kSuccess;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> helixContextCmd::appendSyntax()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> status;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a> mySyntax = syntax();\n\
    if (MS::kSuccess != mySyntax.addFlag(kNumberCVsFlag,\n\
        kNumberCVsFlagLong, <a href=\"javascript:void(0)\" data-symbol=\"MSyntax::kUnsigned\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html#ae6f2057f0d0419845a48c1eb6813f2ada499591c04ccb62ab4f6fc3a5450afd4c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax::kUnsigned</a>)) {\n\
            return MS::kFailure;\n\
    }\n\
    if (MS::kSuccess != mySyntax.addFlag(kUpsideDownFlag,\n\
        kUpsideDownFlagLong, <a href=\"javascript:void(0)\" data-symbol=\"MSyntax::kBoolean\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html#ae6f2057f0d0419845a48c1eb6813f2ada8cfc0ab572a96edfc9db7c02f0d025d7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax::kBoolean</a>)) {\n\
            return MS::kFailure;\n\
    }\n\
    return MS::kSuccess;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> initializePlugin( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> obj )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> status;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin</a> plugin( obj, \"Autodesk\", \"1.0\", \"Any\");\n\
    // Register the context creation command and the tool\n\
    // command that the helixContext will use.\n\
    // \n\
    status = plugin.registerContextCommand(\n\
        \"helixToolContext\", helixContextCmd::creator,\n\
        \"helixToolCmd\", helixTool::creator,\n\
        helixTool::newSyntax);\n\
    if (!status) {\n\
        status.perror(\"registerContextCommand\");\n\
        return status;\n\
    }\n\
    return status;\n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA8E\"></a>The <span class=\"code\" translate=\"no\">initializePlugin()</span> method registers both the helix command and the context via a single register call.\n\
            \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> uninitializePlugin( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> obj)\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> status;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin</a> plugin( obj );\n\
    // Deregister the tool command and the context\n\
    // creation command.\n\
    //\n\
    status = plugin.deregisterContextCommand(\n\
        \"helixToolContext\" \"helixToolCmd\");\n\
    if (!status) {\n\
        status.perror(\"deregisterContextCommand\");\n\
        return status;\n\
    }\n\
    return status;\n\
}\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FA8F\"></a>MEL code similar to the marqueeTool example’s is necessary to attach the helixTool\n\
            to the UI. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";