var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-E2B6A0AD-1F73-47BB-A958-C58AF1586FE4\">\n\
      <meta name=\"description\" content=\"This page provides a brief description of how the dependency graph works.\">\n\
      <meta name=\"indexterm\" content=\"dependency graph nodes, API\">\n\
      <meta name=\"indexterm\" content=\"nodes: for dependency graph, API\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>About the dependency graph</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E2B6A0AD-1F73-47BB-A958-C58AF1586FE4\"></a><div class=\"head\">\n\
            <h1>About the dependency graph</h1>\n\
         </div>\n\
         <p class=\"blurb\">This page provides a brief description of how the dependency graph works. </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBB3\"></a>  The dependency graph (DG) is a collection of entities connected together. Unlike the\n\
            DAG, these connections can be cyclic, and do not represent a parenting relationship.\n\
            Instead, the connections in the graph allow data to move from one entity in the graph\n\
            to another. The entities in the graph which accept input, perform computations, and\n\
            output new data, are called dependency graph nodes. Dependency graph nodes are used\n\
            for almost everything in Maya such as model creation, deformation, animation, simulation,\n\
            and audio processing. \n\
         </p>\n\
         <p><a name=\"GUID-B43232D9-4074-414E-9D42-1718B6275202\"></a> Nodes are the engines which drive the dependency graph. Data comes in to nodes, they\n\
            perform an operation on the data, and they make the new data available again. The\n\
            data comes in through the input plugs (instantiations of the nodes attributes) and\n\
            goes out through the output plugs. At no time should a node require any additional\n\
            external data beyond what is available through its plugs. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBB7\"></a>Most objects in Maya are dependency graph nodes, or networks of nodes (several nodes\n\
            connected together). For example, DAG nodes are dependency graph nodes, and shaders\n\
            are networks of nodes. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBB8\"></a>When dependency graph nodes are connected together they can affect DAG nodes and thus\n\
            affect what is rendered. \n\
         </p><a name=\"FIG_1B714D47EE324BFC82F440EFD6625144\"></a><div class=\"figure-anchor\"><img src=\"images/comp_Transform05.png\"></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBBA\"></a>This illustration combines a DAG hierarchy with a dependency graph. Transform1, Transform2,\n\
            Transform3, and Sphere are all DAG nodes (and also dependency graph nodes) while Time\n\
            is just a dependency graph node. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBBB\"></a>The x, y, and z scale parameters of Transform3 are driven by time. Alternatively,\n\
            you can think of the output of Time being plugged into the x, y, and z scale connections\n\
            of Transform3. When the animation is played back, the two instances of the sphere\n\
            increase in size. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBBC\"></a>The data which flows through the graph can be as simple as numbers, or as complicated\n\
            as a surface. It can also be a completely user-defined object. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBBD\"></a>The dependency graph consists of a very complex architecture, and a complete explanation\n\
            of how it works would require a separate manual. A brief explanation is provided instead.\n\
            \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBBE\"></a>As noted before, the dependency graph is a directed graph, the edges of the graph\n\
            connect plugs on different nodes. Data is sent along these edges, and includes basic\n\
            types such as numbers, vectors, and matrices, and complex types such as curves, surfaces,\n\
            and user defined types. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBBF\"></a>As part of the definition of Maya nodes, you are required to specify which input attributes\n\
            affect which output attributes (in the API this is done with the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::attributeAffects()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#aef755adb241fbe273368fefae14047a4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode::attributeAffects()</a></span> method). \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBC0\"></a>When an attribute of a node is changed, the dependency graph checks to see if that\n\
            attribute affects any output. If it does, each of those outputs is marked dirty, meaning\n\
            that its cached value is stale and needs to be recomputed. Then for each of those\n\
            output attributes, the dependency graph checks to see if they are the source for a\n\
            connection. If so, then the connection is followed, and the destination attribute\n\
            is marked dirty also. This process recurs, and at the end all attributes of nodes\n\
            in the graph which need to be recomputed are marked dirty. It is important to note\n\
            that at this time no attributes have been recomputed, instead the state has just been\n\
            updated so we know which data is no longer valid. The evaluation and re-computation\n\
            of those invalid attributes occurs as part of a separate step. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBC1\"></a>Certain events cause the dependency graph to re-evaluate itself, examples being screen\n\
            refresh, and animation playback. During a refresh for example, the system will walk\n\
            down the DAG and for each DAG node check to see whether it needs to be re-evaluated\n\
            (by checking if any plugs on it are dirty), if so, the compute method of the node\n\
            affecting the plug will be called. This compute method may be dependent on plugs which\n\
            may also be dirty, so the affecting nodes’ compute methods would also be called, and\n\
            in this way the pertinent parts of the DG will be re-evaluated, but only those parts\n\
            that require re-evaluation. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBC2\"></a>One optimization is that the DG does not re-evaluate the graph unless it needs to.\n\
            For example, imagine a revolved surface where there are three nodes, a curve DAG node\n\
            used as input to the second node, a node which revolves the curve and generates a\n\
            surface, which is the output to the third node, a DAG node which puts the surface\n\
            into the DAG. If the input curve was modified, the surface would not be regenerated\n\
            immediately, it may not happen until the next screen refresh. To make sure that the\n\
            surface does eventually get rebuilt, modifying the curve would cause all plugs connected\n\
            to the curve’s output plug to be marked dirty, hence the input to the revolve node\n\
            would be marked dirty (the curve’s output plug itself would not be marked dirty since\n\
            it has just been recomputed). When declaring attributes it’s necessary to indicate\n\
            what attributes affect each other, so in the revolve node, the output attribute is\n\
            dependent on the input attribute, then marking the input attribute dirty causes the\n\
            output attribute to be marked dirty. The output of the revolve node is connected to\n\
            the surface node, marking the revolve node’s output dirty marks the surface as being\n\
            dirty. So, when the DAG is walked during a screen refresh, since the surface is marked\n\
            dirty, everything that it is dependent on which has also been marked dirty needs to\n\
            be re-evaluated. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBC3\"></a>Re-evaluation stops at the first node which doesn’t have any dirty inputs. For example\n\
            if the number of degrees to revolve a curve was changed but the curve itself was not,\n\
            then rebuilding the revolved surface would cause the revolve node to be recomputed,\n\
            but the curve would not be affected. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBC4\"></a>This is a high level description, the actual implementation provides a great deal\n\
            of intelligence so that unnecessary evaluations are avoided. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBC5\"></a>The data flowing through the graph is analogous to water flowing through pipes. The\n\
            pipes themselves are the connections but unless they have data to redirect and modify\n\
            they are not actually doing anything. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBC6\"></a>Extending this analogy, the nodes are like taps, showers, or fountains. They all do\n\
            something with the water in their own unique way but they must have water to operate.\n\
            \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBC7\"></a>An interesting side effect of using the DG is that it can make it difficult to directly\n\
            affect an object. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBC8\"></a>For example, consider the sphere in the above figure. If no DG node is connected to\n\
            Transform3 to affect the sphere’s scale, any values set through the UI or API will\n\
            be the new scale. However, if as in the figure Time affects the scale of the sphere,\n\
            the effect would be different when Transform3’s scale is additionally modified through\n\
            the UI or API. If you set the scale it would override the scale being set by Time\n\
            only until the next re-evaluation of the dependency graph, when the scale of the sphere\n\
            would again be set by Time and the value you set through the UI or API would be lost.\n\
            \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBC9\"></a>A more complex example would be a revolved surface. What would happen if you tried\n\
            to move a CV on the generated surface? The CV would be moved to its new position only\n\
            until the DG is re-evaluated, at which time the CV would be moved back to the position\n\
            dictated by the revolve node. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBCA\"></a>However, fine-tuning or \"tweaking\" a model is a necessary operation for building complex\n\
            models and scenes. So Maya has designed a mechanism for handling these tweaks. Mesh\n\
            shapes have an attribute, pnts, which stores local changes made to the mesh vertices.\n\
            Any upstream connection to the mesh shape node which generates a new set of vertices\n\
            for the mesh will not disturb the pnts attribute. The values in the pnts attribute\n\
            are added to the coordinates of the mesh. For NURBS surfaces and other control point\n\
            based nodes, the controlPoints attribute stores tweak information. Maya also has implemented\n\
            a tweak node which will store tweak information for a control point based node. The\n\
            tweak node is placed between the control point based node and an upstream deforming\n\
            node which operates on the control points. The tweak node integrates the tweak information\n\
            in with the deformed control points to generate the final set of control points that\n\
            is then passed to the shape. Refer to the manual pages for the tweak node as well\n\
            as the mesh and NURBS surface shape nodes for more information on the attributes which\n\
            handle tweak information. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_C31472FB9FBD47169FDD6B1E45147743\"></a> \n\
            <h2><a name=\"GUID-991C4957-2D14-4196-8E9A-15C98DEDDCCB\"></a>Node states\n\
            </h2> \n\
            <p><a name=\"GUID-43470FCA-3D07-4D8B-A82A-7627BB26D758\"></a>Every dependency graph node has a state value that indicates how it should be evaluated.\n\
               Maya users can set and retrieve these values in the Maya UI, through MEL or Python\n\
               commands, and through the API. The state is stored as an integer in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::state\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#ab1315838f80fd570104dc41d834d8ff5&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode::state</a></span> attribute. \n\
            </p> <a name=\"TABLE_1E565E1518BE4090AF683D8969294779\"></a><div class=\"table-ruled\">\n\
               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                  <colgroup>\n\
                     <col>\n\
                     <col>\n\
                     <col>\n\
                  </colgroup>\n\
                  <tr class=\"ruled-heading\">\n\
                     <th class=\"table-heading\">state value </th>\n\
                     <th class=\"table-heading\">state </th>\n\
                     <th class=\"table-heading\">description </th>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <a name=\"GUID-B269E42C-C79D-4E1A-8666-A9F9BDB378F3\"></a><p class=\"table-body\">0 </p> \n\
                     </td>\n\
                     <td class=\"table-body\"> <a name=\"GUID-95953C77-5DA0-4A33-9099-6DCA9B52B2BC\"></a><p class=\"table-body\"> <em class=\"mild\">Normal</em> \n\
                        </p> \n\
                     </td>\n\
                     <td class=\"table-body\">This is the normal, default node state. A node in this state should be evaluated normally.\n\
                        \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-even-row\">\n\
                     <td class=\"table-body\"> <a name=\"GUID-62B73B22-5B43-45A5-A425-2ABAB990349C\"></a><p class=\"table-body\">1 </p> \n\
                     </td>\n\
                     <td class=\"table-body\"> <a name=\"GUID-507F955D-9B14-40DD-9871-1731FC578DC1\"></a><p class=\"table-body\"> <em class=\"mild\">HasNoEffect</em> \n\
                        </p> \n\
                     </td>\n\
                     <td class=\"table-body\"> <a name=\"GUID-3B16A136-F192-4767-BF34-C603202321C8\"></a><p class=\"table-body\">The <em class=\"mild\">HasNoEffect</em>, or <em class=\"mild\">pass-through</em>, state indicates that the node should allow its input data to pass through the node\n\
                           unchanged. It is used in cases where the node performs some computations on an input\n\
                           value and produces an output of the same type. This allows a user to easily disable\n\
                           the computations in a node without disconnecting the node from the surrounding graph.\n\
                           \n\
                        </p> <a name=\"GUID-7DA6F259-0F16-4F83-9211-F45DCEC605DA\"></a><p class=\"table-body\">For example, nearly all deformers support this state by sending the input geometry\n\
                           directly to the output attribute without deforming it. However, nodes that produce\n\
                           different types of outputs from the inputs they accept typically do not support this\n\
                           state. \n\
                        </p> <a name=\"GUID-C666459A-1803-4C93-8DDB-A42BE7C184CD\"></a><p class=\"table-body\">When you write a custom dependency node class, you may choose to support this state.\n\
                           For details, see <span class=\"char_link\"><a href=\"#!/url=./files/Dependency_graph_plugins_Compute_methods.htm\">Implementing the compute() method for a dependency graph node</a></span>. \n\
                        </p> \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <a name=\"GUID-8F35A7DE-2116-466B-9C94-9ABEFC88E5F1\"></a><p class=\"table-body\">2 </p> \n\
                     </td>\n\
                     <td class=\"table-body\"> <a name=\"GUID-7649EE46-85AF-4230-9756-A09D375A54B7\"></a><p class=\"table-body\"> <em class=\"mild\">Blocking</em> \n\
                        </p> \n\
                     </td>\n\
                     <td class=\"table-body\"> <a name=\"GUID-73C70745-28B5-43CF-9EAF-DAFC07BF95AC\"></a><p class=\"table-body\">The <em class=\"mild\">Blocking</em> state is implemented in the dependency node base class, and applies to all nodes.\n\
                           Blocking is applied to connections during the evaluation phase. An evaluation request\n\
                           to a blocked connection will fail, causing the destination plug to retain its current\n\
                           value. Since blocked connections are never cleaned, this state affects dirty propagation.\n\
                           \n\
                        </p> <a name=\"GUID-CBED54B6-EC79-4A98-90BD-09CFB5ADEC14\"></a><p class=\"table-body\">When a node is set to <em class=\"mild\">Blocking</em>, the behavior is supposed to be the same as if all outgoing connections were broken.\n\
                           As long as nobody requests evaluation of the blocked node directly, it will not evaluate\n\
                           again. Note that a blocked node will still respond to <span class=\"code\" translate=\"no\">getAttr()</span> requests, but a <span class=\"code\" translate=\"no\">getAttr()</span> of a downstream node will not re-evaluate the blocked node. \n\
                        </p> <a name=\"GUID-5F040A13-4D9F-46AE-B56A-88399C1C75DA\"></a><p class=\"table-body\">Setting the root transform of a hierarchy to <em class=\"mild\">Blocking</em> won’t automatically influence child transforms in the hierarchy. Instead, you must\n\
                           explicitly set each child node to the <span class=\"code\" translate=\"no\">Blocking</span> state. For example, you could use the following script: \n\
                        </p> \n\
                        <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
def blockTree(root):\n\
    nodesToBlock = []\n\
    for node in {child:1 for child in cmds.listRelatives( root, path=True, allDescendents=True )}.keys():\n\
        nodesToBlock += cmds.listConnections(node, source=True, destination=True )\n\
    for node in {source:1 for source in nodesToBlock}.keys():\n\
        cmds.setAttr( \'%s.nodeState\' % node, 2 )\n\
</pre></div> <a name=\"GUID-DAB96228-28F1-49A4-9C97-C3E35DB3FFE6\"></a><p class=\"table-body\">Applying this script would continue to draw objects, but child nodes would not be\n\
                           animated. \n\
                        </p> <a name=\"GUID-516E6C9D-C104-4C9B-876F-ADEEC6DEA153\"></a><p class=\"table-body\">When you write a custom dependency node class, you do not need to check for this case,\n\
                           since it is handled automatically by the base <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span> class. \n\
                        </p> \n\
                     </td>\n\
                  </tr>\n\
               </table>\n\
            </div> \n\
            <p><a name=\"GUID-F4E5C788-D437-484A-B054-D8A9464D7E1D\"></a>Three other states exist for internal use only: <em class=\"mild\">Waiting-Normal</em>, <em class=\"mild\">Waiting-HasNoEffect</em>, and <em class=\"mild\">Waiting-Blocking</em>. These nodes temporarily shut off parts of the graph during user interaction (e.g.\n\
               while manipulating the graph). Once the interaction is done, Maya will reset the node\n\
               state appropriately. You should never need to worry about these states. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";