var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-0B82C890-45DA-49AE-91C3-41997DD90E58\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Overview of the Maya API Internationalization Architecture</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0B82C890-45DA-49AE-91C3-41997DD90E58\"></a><div class=\"head\">\n\
            <h1>Overview of the Maya API Internationalization Architecture</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-813\"></a>Maya is an internationalized application. It can support alternate languages in its\n\
            user interface and it is compatible with localized user environments requiring either\n\
            single-byte or multi-byte text encodings. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755360AA6ED11A9C1EFFAA-6B81\"></a>Maya runs in English by default. When Maya is running in an alternate language, user\n\
            messages, menus, labels and other user interface text are displayed with translated\n\
            values in place of the default English values. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755360AA6ED11A9C1EFFAA-6B80\"></a>Read this section if you want to write plug-ins that are compatible within localized\n\
            user environments and operate correctly with both single and multi-byte text encodings.\n\
            You can also find information on how to adapt plug-in code and scripts to support\n\
            one or more alternate user interface languages. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-811\"></a>This section gives an overview of the main concepts and features that provide internationalization\n\
            and localization support in the Maya API. Implementation details and examples are\n\
            found in subsequent sections. \n\
         </p>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-810\"></a> \n\
            <h2><a name=\"GUID-6F706D39-B539-4722-A628-B2A69265C6BF\"></a>Internationalization and Localization\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-80F\"></a>There are two main processes involved in preparing plug-ins to run in alternate languages\n\
               and locales: internationalization and localization. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-80E\"></a> <em class=\"strong\">Internationalization</em> is the process of changing the executable code and scripts so that they can be localized.\n\
               In the context of plug-ins this mainly involves replacing hard-coded user interface\n\
               strings with string resources that can be changed to match the user\'s language choice.\n\
               String handling code may also require changes to work correctly in all language encodings.\n\
               \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-80D\"></a> <em class=\"strong\">Localization</em> is the process of customizing the plug-in to work in a particular language. For a\n\
               plug-in this will mainly involve translating the user interface strings and installing\n\
               them correctly in the plug-in resource path. Once the code is internationalized, it\n\
               can be localized for one or more target languages. \n\
            </p> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-80C\"></a> \n\
               <h3><a name=\"GUID-F8967FF1-1E35-4282-B49C-87B017540346\"></a>Single-binary Strategy\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-80B\"></a>The Maya application is internationalized using a single-binary strategy. This means\n\
                  that the same executable code can support different languages. All data that varies\n\
                  between user language selections is external to the software itself and is supplied\n\
                  as separate localization-packages. The software itself does not need to be re-built\n\
                  to support a different user language or to run under different codepage settings.\n\
                  This philosophy extends to the internationalization features provided in the Maya\n\
                  API. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-80A\"></a> \n\
               <h3><a name=\"GUID-81C81168-2891-4D76-9B94-D5A031BAB907\"></a>Locales and Encodings\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-809\"></a>Localized user environments will have different locale and codepage (encoding) settings.\n\
                  Maya automatically determines the user language preference and the associated locale\n\
                  and codepage. The manner in which these are determined from user preferences differs\n\
                  across hardware platforms, and is described in the Maya Documentation. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-808\"></a>To see what user interface language and codepage Maya is using, type the following\n\
                  commands: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
about -uiLanguage;\n\
about -codeset;\n\
</pre></div> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-807\"></a>To a large extent, proper use of the Maya API classes and methods insulate plug-in\n\
                  code from the locale settings and their implications. It is important however to understand\n\
                  that these settings affect how string data is interpreted and how external interfaces\n\
                  will behave, especially when dealing with multi-byte locales. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-806\"></a> \n\
               <h3><a name=\"GUID-F6B5CE08-AC55-4CA6-BFFC-42F34D790635\"></a>Localized Strings \n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-805\"></a>The Maya API has its own string class, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span>, which is used throughout the API to pass textual data between methods. <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span> provides methods for manipulating and accessing the string data, which to a large\n\
                  extent insulate the code from any concern about the underlying representation of the\n\
                  string. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-804\"></a>The application locale affects the behavior of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span> methods that accept or return string data in character (<span class=\"code\" translate=\"no\">char *</span>) buffers, since the correct data encoding must be used to interpret the character\n\
                  stream. In some cases adaptations to plug-in code accessing or manipulating character\n\
                  buffers will be required to ensure the strings are treated correctly, especially in\n\
                  multi-byte environments. More information about using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span> and its methods in a localized environment can be found under String Handling below.\n\
                  \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-803\"></a> \n\
               <h3><a name=\"GUID-FC1F7836-0899-495D-AB23-D7F75F9AFD3B\"></a>String Resources\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-802\"></a>The Maya API has been extended to provide a string resource mechanism for plug-ins.\n\
                  This allows plug-ins to add strings to the Maya String Catalog. Localized values for\n\
                  these strings can be provided for use when Maya is running in an alternate language.\n\
                  \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-801\"></a>Plug-in string resources can be used in both C++ code and MEL scripts. The plug-in\n\
                  resource architecture is designed so that the default (English) string values are\n\
                  specified directly in the plug-in source code (C++ or script). The default values\n\
                  are \"built-in\" and are always available.\n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-800\"></a>Localized resource values are provided in external files that are read and loaded\n\
                  into Maya\'s string catalog when the plug-in is loaded. Adding localized resources\n\
                  does not require rebuilding the plug-in executable. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7FF\"></a>Localized resources are optional. One advantage to this approach is that plug-ins\n\
                  can be adapted to use string resources but the localization (or translation) of the\n\
                  resources can be deferred until a later time. The localized values will only be used\n\
                  if they are available and match the user\'s language choice. If localized resources\n\
                  are not found for any reason the plug-in will run as before with the default (built-in)\n\
                  string values. \n\
               </p> \n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";