var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-20C84E3A-D004-4D9E-9632-D15C795DEB66\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Render Targets and Render Target Manager</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-20C84E3A-D004-4D9E-9632-D15C795DEB66\"></a><div class=\"head\">\n\
            <h1>Render Targets and Render Target Manager</h1>\n\
         </div>\n\
         <p><a name=\"GUID-06632567-1C45-40FC-BA4B-46E5DBECD385\"></a>A unified mechanism for hardware (GPU) <em class=\"strong\">render target</em> creation and management is exposed in the API. All render targets are managed by\n\
            the resource manager and are cached for reuse. Any kind of resource management for\n\
            resizing targets is also handled by the resource manager. As with other GPU resources,\n\
            the interface can encapsu­late the resource in a draw API agnostic manner. \n\
         </p>\n\
         <p><a name=\"GUID-8BA9E825-89DC-488E-AF25-79619554503E\"></a>A render target can be described as a target block of pixels (buffer) into which rendering\n\
            will occur. \n\
         </p>\n\
         <p><a name=\"GUID-69C34A85-A5E4-4C04-998C-F10D6ED80431\"></a>A render target should not be thought of as an onscreen output buffer such as DirectX\n\
            SwapChain, nor an Open frame buffer or an OpenGL context. This goes back to the notion\n\
            that the renderer is not necessarily a viewport, which assumes that rendering into\n\
            a viewport is the same as rendering into an OpenGL context. \n\
         </p>\n\
         <p><a name=\"GUID-77396CB8-C56B-4DD3-972F-A75AD212D34B\"></a>In the API a render target is represented by an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderTarget\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_render_target.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_target.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderTarget</a></span>. \n\
         </p>\n\
         <p><a name=\"GUID-4D3442F6-E57D-4CDA-8642-FC8C6BF45FA7\"></a>It is possible to have a target which: \n\
         </p><a name=\"OL_01857D6B2B9C4379AD38A5359BE7CD6C\"></a><ol type=\"1\" start=\"1\">\n\
            <li>Holds color values. This is called a color target. </li>\n\
            <li>Holds depth values. This is called a depth target. </li>\n\
            <li>Holds depth and stencil values. This is called a depth+stencil target. </li>\n\
         </ol>\n\
         <p><a name=\"GUID-39668964-2DE9-45D8-AC84-0D3BE2FEDCD3\"></a>The most accurate description of a colour and depth target is that it’s a texture\n\
            that can be rendered into. One or more color targets and/or a depth target can be\n\
            set to indicate where rendering is actively being sent to. \n\
         </p>\n\
         <p><a name=\"GUID-797F9AB3-0DF0-444D-B16B-174867A697A6\"></a>In legacy interfaces, only one format was supported for color and one for depth. This\n\
            was fixed RGBA 24-bit color and fixed 24-bit depth. The stencil format support remains\n\
            single channel 8-bit fixed point. The current possible variations are described using\n\
            an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderTargetDescription\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_target_description.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_target_description.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderTargetDescription</a></span>. This descriptor includes options for: \n\
         </p><a name=\"UL_5586F3DB7D6442839DFC0234224D437E\"></a><ul>\n\
            <li><em class=\"mild\">Name</em>: A name which uniquely identifies the resource. It is possible to have multiple targets\n\
               with the same format but having a different name. \n\
            </li>\n\
            <li><em class=\"mild\">Dimensions</em>: Width and height. \n\
            </li>\n\
            <li><em class=\"mild\">Hardware multisampling parameters</em>: MSAA. \n\
            </li>\n\
            <li><em class=\"mild\">Raster format</em>: Indicates whether this is a color or depth target, the number of channels, the channel\n\
               ordering, and the bit precision per channel. \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"GUID-C7226408-ACA8-4C93-9CB7-A8D4448C2982\"></a>The process to acquire a render target is as follows: \n\
         </p><a name=\"OL_BF0425D722724712A46CB468CFF2F10D\"></a><ol type=\"1\" start=\"1\">\n\
            <li>Create and fill in a descriptor (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderTargetDescription\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_target_description.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_target_description.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderTargetDescription</a></span>) for a render target. \n\
            </li>\n\
            <li>Attempt to acquire a target from the target manager (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderTargetManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_target_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_target_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderTargetManager</a></span>) \n\
            </li>\n\
            <li>It is possible that this acquire can fail and is dependent on the video card, the\n\
               card driver and the currently available resources. For instance render targets can\n\
               use up a fair amount of GPU memory and it is possible to fail trying to create a target\n\
               with large dimensions, high bit depth and a multisampling parameter value. \n\
            </li>\n\
         </ol>\n\
         <p><a name=\"GUID-321E4D10-93BC-4E1F-B28C-CA07BDC5374C\"></a>To avoid the complications of target management, a convenient method has been provided\n\
            on the target to allow a new descriptor to be set. Whenever this method is invoked,\n\
            a format change or a resize is attempted. As with an initial acquire, it is possible\n\
            that the resize may fail. \n\
         </p><img src=\"images/GUID-76051A74-AE89-48CB-899D-F9C489D61ACA-low.jpg\"><p><a name=\"GUID-4A093FD8-F21E-4371-99B9-5B49D58F9A2C\"></a>Figure 32: On the left are 2 possible render targets. The target with the name “MyColorTarget”\n\
            is a color target with an R16G16_Float. The second target named “MyDepthTarget” is\n\
            a 32 bit floating point depth target. The names are used to reference the actual render\n\
            targets on the GPU. On the right is the layout for acquisition and update. The “Update\n\
            Description” action attempts to update the GPU resource via another acquire \n\
         </p>\n\
         <p><a name=\"GUID-5CE1E375-088F-4067-8011-B00BDA2E568D\"></a>It is possible to access the resource handle for color and depth render targets but\n\
            not necessarily a depth+stencil target. For DirectX11, color and depth targets are\n\
            returned as a reference to a view (ID3D11RenderTargetView) of a target. Depth+stencil\n\
            targets are returned as depth stencil (ID3D11DepthStencilView) views. For OpenGL,\n\
            color and depth targets are returned as references to textures (integer texture identifier).\n\
            Depth+stencil targets are not accessible. It is possible to modify the contents of\n\
            the target directly but is generally not recommended. Plug-ins should never delete\n\
            the underlying resource. \n\
         </p>\n\
         <p><a name=\"GUID-2E6D98DD-3FCC-4E35-AA64-7C329EA44137\"></a>To avoid confusion, the legacy interface, which is also called <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderTarget\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_render_target.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_target.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderTarget</a></span> differs from the construct discussed here which is in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MHWRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_m_h_w_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender</a></span> namespace (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MRenderTarget\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_target.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MRenderTarget</a></span>). The previous definition is simply a wrapper around a viewport OpenGL context and\n\
            has no relation to this framework. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";