var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-2BEF58D3-6162-4235-A6CE-3D8B0742A0AE\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Threading and Maya</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2BEF58D3-6162-4235-A6CE-3D8B0742A0AE\"></a><div class=\"head\">\n\
            <h1>Threading and Maya</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55C5\"></a> \n\
            <h2><a name=\"GUID-DEDFD247-A616-45B7-8793-CE84860547AE\"></a>Maya API threading interface, description and examples\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55C4\"></a>Having laid the groundwork by describing required threading functionality, this section\n\
               discusses the functionality provided by the Maya API, and illustrates usage with some\n\
               example plug-ins supplied with Maya. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55C3\"></a>In Maya, a number of threading classes exist to provide support for thread creation,\n\
               management and locking. These threading classes build on Intel\'s TBB threads, which\n\
               are used internally by Maya. The classes expose a native threading-like API to plug-in\n\
               writers. Note that these classes do not require the plug-in writer to use TBB directly\n\
               in their plug-ins, or even be familiar with TBB. Since these threads are actual internal\n\
               Maya threads, they respect thread count settings applied in Maya, and avoid the problem\n\
               of creating increasing numbers of active threads as plug-ins are themselves threaded.\n\
               They also provide protection from oversubscription problems in some cases due to the\n\
               way TBB implements threading. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55C2\"></a>The API provides the following three major areas of functionality: \n\
            </p> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55C1\"></a><ul>\n\
               <li>fork-join threading implementation model </li>\n\
               <li>asynchronous task-based threading model </li>\n\
               <li>threading synchronization interfaces </li>\n\
            </ul> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55BD\"></a>The architecture employs object reference counting to assist with memory management\n\
               and to delay deallocation of objects until all users of the object are finished with\n\
               it. A successful call to an API function returns an interface pointer, and the caller\n\
               is responsible for calling <span class=\"code\" translate=\"no\">release()</span> on that interface when they are finished with it. Failure to do so could lead to\n\
               memory leaks. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55BC\"></a>The return <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a></span> of calls should always be checked, as it should never be assumed that a call will\n\
               always succeed. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55BB\"></a> \n\
            <h2><a name=\"GUID-0887E609-965B-4F05-ABB7-AA327B337F38\"></a>Thread creation and management using the Maya API\n\
            </h2> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55BA\"></a> \n\
               <h3><a name=\"GUID-7142D346-67DB-476C-8047-4F18D14EEA6E\"></a>MThreadPool\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B9\"></a>This class creates or reuses a thread pool. Since creation and deletion of threads\n\
                  is expensive, it is a good idea to make use of the thread pool where possible, and\n\
                  try to keep it around between invocations of the plug-in rather than recreate it each\n\
                  call. The thread pool is reference counted, so it is possible to create it in the<span class=\"code\" translate=\"no\"> initialize()</span> method of the plug-in and keep it for the duration of the application, releasing\n\
                  it in the <span class=\"code\" translate=\"no\">uninitialize()</span> method. It provides methods common to native threading implementations, allowing\n\
                  for migration of plug-ins from native threads over to this API. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B8\"></a>The implementation requires the creation of a fork-join context which takes a function\n\
                  pointer as an argument. This function needs to implement the decomposition of the\n\
                  given problem into smaller chunks (tasks) which are then mapped to threads by TBB\n\
                  internally. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B7\"></a>Note that the use of TBB internally means that it is possible to nest threaded fork-join\n\
                  regions created with <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MThreadPool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MThreadPool</a></span> without causing oversubscription, as TBB will schedule all the tasks in parallel\n\
                  by mapping them to cores. \n\
               </p> \n\
               <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B6\"></a> \n\
                  <h4><a name=\"GUID-24D2206A-276D-42D7-B8E8-561BA44DA691\"></a>Example\n\
                  </h4> \n\
                  <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B5\"></a>See the example plug-in <span class=\"code\" translate=\"no\">threadTestCmd</span>, supplied with Maya, which computes prime numbers using a thread pool. This requires\n\
                     the creation of a new function, <span class=\"code\" translate=\"no\">DecomposePrimes</span>, to decompose the problem into smaller parts. The code within <span class=\"code\" translate=\"no\">DecomposePrimes</span> looks very similar to a native threading implementation, the main difference being\n\
                     the use of the control variable NUM_TASKS rather than the number of threads. As discussed\n\
                     above, TBB internally takes care of mapping the tasks to threads, and ensures optimal\n\
                     load balancing. \n\
                  </p> \n\
               </div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B4\"></a> \n\
               <h3><a name=\"GUID-D5E54200-ED92-4535-9E3C-A9B2EAFBDF2E\"></a>MThreadAsync\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B3\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MThreadAsync\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_async.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MThreadAsync</a></span> class provides methods common to native threads that allow the user to map independent\n\
                  asynchronous tasks to threads. The current implementation does not use a thread pool\n\
                  for this interface but instead creates new threads for each asynchronous task. This\n\
                  means it is possible to cause oversubscription, so care must be taken in managing\n\
                  the number of asynchronous threads and the amount of work they do concurrently. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B2\"></a>The <span class=\"code\" translate=\"no\">createTask()</span> method takes a function pointer that executes the asynchronous task and also a pointer\n\
                  to a callback function that can be used by developers to implement a fork-join or\n\
                  any other signaling mechanism. \n\
               </p> \n\
               <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B1\"></a> \n\
                  <h4><a name=\"GUID-E65BCFC7-91A2-4099-867E-8F1F9B95F9FE\"></a>Example\n\
                  </h4> \n\
                  <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B0\"></a>Refer to the example plug-in <span class=\"code\" translate=\"no\">threadTestWithLocksCmd.cpp</span>. This plug-in is shipped with Maya. Compared with the thread pool example described\n\
                     previously, this implementation does not require the creation of a separate function\n\
                     like <span class=\"code\" translate=\"no\">DecomposePrimes</span>, as it mimics the native threading API closely. However the asynchronous threading\n\
                     interface does not provide a join method. The example shows how the equivalent functionality\n\
                     may be implemented by implementing barriers in the callback functions (<span class=\"code\" translate=\"no\">WaitForAsyncThreads</span>.) \n\
                  </p> \n\
                  <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AF\"></a>The function <span class=\"code\" translate=\"no\">Maya_InterlockedCompare()</span> could be implemented more efficiently using the atomic <span class=\"code\" translate=\"no\">compareAndSwap()</span> method in the <span class=\"code\" translate=\"no\">MAtomic.h</span> header provided with the Maya API. \n\
                  </p> \n\
               </div> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AE\"></a> \n\
            <h2><a name=\"GUID-561189A5-90B3-40F8-8106-6553C27C3ADF\"></a>Locking operations using the Maya API\n\
            </h2> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AD\"></a> \n\
               <h3><a name=\"GUID-F8EA8029-A163-4ADB-828D-74391231BD6E\"></a>System locks\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AC\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMutexLock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_mutex_lock.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMutexLock</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSpinLock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_spin_lock.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSpinLock</a></span> are system locks. <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMutexLock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_mutex_lock.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMutexLock</a></span> uses <span class=\"code\" translate=\"no\">pthread_mutex_lock</span> on OSX and Linux, and <span class=\"code\" translate=\"no\">EnterCriticalSection</span> on Windows. The difference between these is that a mutex lock is a heavier operation\n\
                  but requires no CPU resources once the lock is held. A spin lock is a light operation,\n\
                  but requires heavy CPU resources while waiting. So if the wait is likely to be short,\n\
                  use a spin lock. These classes release the lock in their destructor, meaning explicit\n\
                  release is not required, and the lock will be safely released even if an exception\n\
                  is thrown in the locked code. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AB\"></a>It is best to use different instances of lock objects for unrelated code. If a single\n\
                  lock object is used in many different places, threads may be blocked even if working\n\
                  on unrelated tasks. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AA\"></a> \n\
               <h3><a name=\"GUID-75F72391-2D19-4B3F-8036-8714DB49CA19\"></a>Atomic operations\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A9\"></a>The Maya API includes an implementation of atomic operations in the API header called\n\
                  <span class=\"code\" translate=\"no\">MAtomic.h</span> which provides cross-platform atomic operation functionality. Below is a listing\n\
                  of the atomic operations available. Full descriptions are given in the file itself\n\
                  and in the Maya API class documentation. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::preIncrement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#a6e8874b8bf5bfffb6fac137dba28f888&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::preIncrement</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::postIncrement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#ac2c0d7597183016c73e3e44f3eca453b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::postIncrement</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::increment\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#acddba9e14f0627bf4e38792f81a47fd4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::increment</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::preDecrement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#aa9a012890f5cbfe4b7cb76d29d934fd9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::preDecrement</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::postDecrement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#a65228d140e8bc76f047708eaff3a9210&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::postDecrement</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::decrement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#afe75af9726e9e7070d5a4ded46b49df2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::decrement</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#afadcfa2eca88f808d9eb8b3b73c1e515&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::set</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::compareAndSwap\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#ada84e1d5fb08e43440e14bff2793fb69&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::compareAndSwap</a>()\n\
</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A8\"></a> \n\
               <h3><a name=\"GUID-037630F1-C5D2-44B9-B0A8-FF087C55A3A2\"></a>Performance of locking and atomic operations\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A7\"></a>The following are the performance numbers for the cost of spin and mutex locks and\n\
                  atomic operations on Windows 64. (Other platforms are similar with the exception of\n\
                  OSX that mutex is much slower.) The plug-in to generate these numbers is called <span class=\"code\" translate=\"no\">threadingLockTests</span>, and is shipped with Maya as a sample plug-in for you to test performance on your\n\
                  own system. It requires a compiler that supports OpenMP. Note that this plug-in is\n\
                  an extreme case as the code does very little actual parallel work within the locked\n\
                  region. However it does give an indication of the relative cost of these locks under\n\
                  heavy contention. (A contended lock is one where another thread attempts to gain the\n\
                  lock that is already held by one thread. Having more running threads increases the\n\
                  chances of lock contention dramatically. Performance suffers significantly if there\n\
                  is high contention.) \n\
               </p> <a name=\"WS73099CC142F48755-1C09418211F25B18DC4-6308\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-2D358C30-14F0-41A7-BADC-80B031850969-low.png\"></div> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A5\"></a>Note the benefit of atomic operations over the various mutex locks. Also note that\n\
                  code without any locking is far faster than even the atomic implementation. Clearly\n\
                  it is best to avoid locks wherever possible. If not, atomic operations should be used,\n\
                  and only if this is not possible should full mutex or spin locks be used. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A4\"></a> <em class=\"strong\">Lock granularity</em> is a large complex topic in itself. In general it is best to lock at a finer grained\n\
                  level rather than a coarser level, as it allows more opportunities for parallelism.\n\
                  However too much fine grained locking can eat up a lot of system time and add significant\n\
                  complexity to the code. The challenge is to find an optimal balance point between\n\
                  coarse and fine grained locking. Since coarse grained locking is easiest, it is best\n\
                  to start with such locking and then more to progressively finer grained locking until\n\
                  performance stops improving. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-7F10494411F03A24F24-7D47\"></a>The worst locking problems are those that prevent the application from progressing\n\
                  at all: \n\
               </p> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A3\"></a><ul>\n\
                  <li> <em class=\"strong\">Deadlocks</em> occur when two threads each take a different lock, then each attempts to acquire\n\
                     the lock held by the other thread. No further progress is possible and the application\n\
                     hangs. \n\
                  </li>\n\
                  <li> <em class=\"strong\">Livelocks</em> are similar to deadlocks except that each thread continually remains active without\n\
                     progressing past the lock. An example would be code that can detect a deadlock and\n\
                     roll back from it, but then simply allows the same evaluation to recur, leading to\n\
                     an infinitely repeating cycle. \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A0\"></a> \n\
            <h2><a name=\"GUID-C9246247-BDBE-44C3-BFE2-E59DCCDC08EC\"></a>Maya API threading example - deformer\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-559F\"></a>The plug-in <span class=\"code\" translate=\"no\">splatDeformer</span> supplied with Maya is an example of a threaded deformer implementation. This example\n\
               uses OpenMP rather than the Maya native API, since the focus here is on the approach\n\
               taken to threading a deformer rather than the threading implementation itself, and\n\
               OpenMP requires the least amount of additional code to implement threading. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-559E\"></a>The deformer is somewhat similar to a Maya sculpt deformer. A deforming mesh can be\n\
               used to modify a selected mesh. The algorithm applies a deformation to every point\n\
               on the mesh by snapping it to the closest point on the deforming object. The closest\n\
               point operation is computationally intensive, and therefore is a good candidate for\n\
               threading, unlike some simpler deformers where threading overhead is likely to outweigh\n\
               any potential benefit. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-559D\"></a>Here are some items of note in this implementation: \n\
            </p> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-559C\"></a><ul>\n\
               <li>Note that all DG access is performed outside the threaded region. This is because\n\
                  DG access is generally not threadsafe, although there are exceptions (see section\n\
                  <span class=\"char_link\"><a href=\"#!/url=./files/GUID-2BEF58D3-6162-4235-A6CE-3D8B0742A0AE.htm#WS1A9193826455F5FF-5187222B11EEADCDC61-5589\">Threadsafe Maya API methods and classes</a></span> below.) \n\
               </li>\n\
               <li>All the elements are read into arrays using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItGeometry</a></span> rather than using the iterator to do the loop traversal. This again ensures we avoid\n\
                  DG access in threads, and also avoids the problem that it is difficult to thread an\n\
                  iterator (although it can be done with Intel\'s OpenMP <span class=\"code\" translate=\"no\">taskq</span> extension.) \n\
               </li>\n\
               <li>There are fast methods on <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItGeometry</a></span> that read and write all points in a single function call, <span class=\"code\" translate=\"no\">allPositions() </span>and <span class=\"code\" translate=\"no\">setAllPositions()</span>. These are much more efficient than querying and setting the points one by one. If\n\
                  you are working directly with points on an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> in Maya there are new methods <span class=\"code\" translate=\"no\">getRawPoints()</span> and <span class=\"code\" translate=\"no\">getRawNormals()</span> which are even faster as they return a const pointer directly to the internal data.\n\
                  Do not be tempted to cast away the const and modify the data in place via this pointer,\n\
                  as this will almost certainly lead to data corruption. \n\
               </li>\n\
               <li>The closest point methods on <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> are not threadsafe, and are also relatively inefficient for multiple evaluations\n\
                  of a fixed mesh. The class <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMeshIntersector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_mesh_intersector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_mesh_intersector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMeshIntersector</a></span> uses a cached tree traversal so is much faster, and is also threadsafe. The intersector\n\
                  is set up and initialized outside the loop, then evaluated inside the loop to get\n\
                  the full parallelism benefit. \n\
               </li>\n\
               <li>The <span class=\"code\" translate=\"no\">meshPoint</span> object must be allocated inside the loop so it is created on the current thread\'s\n\
                  stack. Allocating the object outside the loop would cause race conditions. Inadvertently\n\
                  writing to variables that were declared outside the loop is a common problem when\n\
                  trying to add threading to code that was not initially threaded, and great care must\n\
                  be taken to track all such variables down. It is good practice to declare variables\n\
                  in as local a scope as possible and avoid the practice of declaring variables at the\n\
                  top of a function anyway, and the fact that it makes any potential threading work\n\
                  easier in future is an additional benefit. It is also worth declaring any variables\n\
                  before the loop as const where possible, so write access to these variables from within\n\
                  the loop can be caught at compile time. \n\
               </li>\n\
               <li>The values are read from a shared array and written into a shared array so there is\n\
                  some risk of cache misses on reads and false sharing on writes. However the default\n\
                  OpenMP traversal scheme for a loop like this would be to have the first thread evaluate\n\
                  the first (nPoints/nThreads) elements and other threads evaluate equal sized contiguous\n\
                  chunks. This access pattern minimizes both cache misses and false sharing. \n\
               </li>\n\
               <li>If one of the closest point operations fails, the evaluator does not immediately abort,\n\
                  but instead sets a bad status flag and skips remaining iterations. In this specific\n\
                  case it is because OpenMP does not permit break calls from inside a threaded region.\n\
                  However it is often the easiest approach in general, compared with attempting to abort\n\
                  other threads that are in mid-evaluation. \n\
               </li>\n\
               <li>After the threaded region, the iterator is used to write the values back into the\n\
                  output object. \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5593\"></a>Scalability is limited by the serial portion of the code. For this reason it is important\n\
               to optimize the code outside the threaded region. So for example it is best to get\n\
               and set data in as large chunks as possible from the DG. This minimizes DG overhead.\n\
               Several methods were added to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> to allow the user to retrieve all components of various types in a single operation,\n\
               specifically for this purpose. The danger of course is increased memory usage, as\n\
               these arrays must be maintained for the duration of the compute method compared with\n\
               the iterator approach that updates one element at a time in place. The method <span class=\"code\" translate=\"no\">MFnMesh::getRawPoints</span> provides maximum speed and avoids memory overhead by returning a pointer directly\n\
               to the internal data. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-7F10494411F03A24F24-7D46\"></a>Some deformers cache their weights in the datablock. Reading from the datablock is\n\
               slow and potentially not threadsafe. Often deformer weights do not change from frame\n\
               to frame anyway, so in such cases it is best to read the weights once and store them\n\
               in local arrays within the deformer class, then do the threaded deformer evaluation\n\
               using those cached weight values. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5592\"></a> \n\
            <h2><a name=\"GUID-E78FFCD3-320F-40C4-8CFE-D42BC38872A2\"></a>Initializing singleton objects in Maya plug-ins\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5591\"></a>A common coding pattern is creation of a singleton object, perhaps initializing global\n\
               data for a solver. Usually this is a very simple operation: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
static solver* singleton = 0\n\
if (singleton == 0) {\n\
&nbsp;&nbsp;&nbsp;singleton = new Solver();\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5590\"></a>However when it comes to threaded code it becomes a very challenging problem, and\n\
               entire papers have been written on the best approach to implementing this pattern,\n\
               the problem being that optimizers often reorder code to break apparently threadsafe\n\
               implementations. An obvious solution is to use a lock, but that is a heavyweight operation\n\
               that is only really required on first construction. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558F\"></a>In general, if the overhead of the initialization is not too large, it is best to\n\
               put it into the<span class=\"code\" translate=\"no\"> initialize()</span> method of the plug-in, which can be guaranteed to run serially. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558E\"></a>If the object is large or expensive to construct, or the plug-in is not always executed,\n\
               it is preferable to use lazy evaluation and initialize the object only when required.\n\
               If this is the case, here is an implementation that may be helpful. It makes use of\n\
               the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MAtomic\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic</a></span> API class supplied with Maya: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
static Solver* singleton = 0\n\
if (singleton == 0) {\n\
&nbsp;&nbsp;&nbsp;&nbsp;Solver* solver = new Solver();\n\
&nbsp;&nbsp;&nbsp;&nbsp;if(!<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::compareAndSwap\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#ada84e1d5fb08e43440e14bff2793fb69&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::compareAndSwap</a>(&amp;singleton, 0, solver)) {\n\
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;delete solver;\n\
&nbsp;&nbsp;&nbsp;&nbsp;}\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558D\"></a>On invocation, multiple threads enter the <em class=\"strong\">if </em>condition and potentially create multiple solvers at the same time. The first thread\n\
               to reach the <span class=\"code\" translate=\"no\">compareAndSwap</span> sets the <span class=\"code\" translate=\"no\">solverSingleton</span> pointer to the address of the new solver, and all subsequent threads delete their\n\
               solver instances once they finish creating them. Although this seems disturbingly\n\
               wasteful at first glance, it is actually very efficient, because the performance hit\n\
               is taken just once on startup, but all subsequent calls to the code just do a simple\n\
               pointer compare, with no locking at all required. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558C\"></a>If it is unsafe to have multiple threads in the Solver constructor, here is an alternative\n\
               template to start from: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
static Solver* singleton = 0\n\
static int doneInit=0;\n\
if(<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::compareAndSwap\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#ada84e1d5fb08e43440e14bff2793fb69&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::compareAndSwap</a>(&amp;doneInit, 0, 1)) {\n\
&nbsp;&nbsp;&nbsp;&nbsp;singleton = new Solver();\n\
&nbsp;&nbsp;&nbsp;&nbsp;doneInit = 2;\n\
}\n\
while(doneInit != 2) {}; // spin-wait\n\
</pre></div> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558B\"></a>This code ensures the solver is only initialized once. To prevent other threads from\n\
               accessing the object after the constructor has initialized the <span class=\"code\" translate=\"no\">solver</span> pointer but before it has finished its work, a spin-wait loop is applied that is\n\
               not exited until the object has been fully initialized. The downside is that this\n\
               approach requires an atomic operation and at least one traversal of the while loop\n\
               for every subsequent call. There is also some concern about the compiler reordering\n\
               the <span class=\"code\" translate=\"no\">doneInit=2 </span>line to above the constructor, so an additional lock around the solver constructor\n\
               call may be required to ensure this is avoided. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558A\"></a>This is a good illustration of how even simple tasks can become tricky in a threaded\n\
               environment. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5589\"></a> \n\
            <h2><a name=\"GUID-A195C59C-A7D1-4987-A89B-C418AB284A6F\"></a>Threadsafe Maya API methods and classes\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5588\"></a>The Maya API is very extensive, and it is not possible at this point to document every\n\
               function and class to indicate whether it is threadsafe. This section focuses on some\n\
               of the key classes that users are likely to want to call from threaded code. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5587\"></a>Unfortunately it is not safe to make any assumptions about which methods may be threadsafe.\n\
               Unless the function is inline and can be checked directly, there is always the risk\n\
               that code may not be threadsafe. Even query methods may occasionally be unsafe as\n\
               their classes may store internal state that is modified by the query. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5586\"></a>Some classes rely on lazy evaluation so certain methods must be \"primed\" by calling\n\
               them once outside a threaded region to update the internal data structure. For example,\n\
               <span class=\"code\" translate=\"no\">MFnMesh::getVertexNormal</span> will first check to ensure the normals are up to date, and if they are not, it will\n\
               recompute them. Thus two simultaneous calls to this function when the normals are\n\
               not up to date will be unsafe. However once one call has been made and the internal\n\
               data structures are updated, subsequent calls are threadsafe as long as the object\n\
               has not been modified since the initial priming call. \n\
            </p> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5585\"></a> \n\
               <h3><a name=\"GUID-485F24E7-ED7B-43E1-98F9-6002BD72B8BD\"></a>Threadsafe classes\n\
               </h3> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5584\"></a><ul>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPoint</a></span>/<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFloatPoint</a></span>/<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVector</a></span>/<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFloatVector</a></span>/<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_matrix.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMatrix</a></span> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5582\"></a><ul>\n\
                        <li>All read-only methods, no write methods. </li>\n\
                     </ul> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\">M*Array</span> container classes \n\
                     <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-557F\"></a>Array classes are safe for read access. For writes, the <span class=\"code\" translate=\"no\">set()</span> methods are safe as they do not resize the array. However<span class=\"code\" translate=\"no\"> append()</span>, <span class=\"code\" translate=\"no\">insert()</span>, <span class=\"code\" translate=\"no\">remove()</span> are not safe as they potentially resize the array. \n\
                     </p> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-557D\"></a><ul>\n\
                        <li>closestPoint/intersection methods are NOT threadsafe. </li>\n\
                        <li>get* and numNormals methods are safe once they have been primed. </li>\n\
                        <li>getRawPoints/getRawNormals are threadsafe. </li>\n\
                     </ul> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMeshIntersector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_mesh_intersector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_mesh_intersector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMeshIntersector</a></span> is threadsafe. \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a></span> - methods can not in general be assumed to be threadsafe. <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5577\"></a><ul>\n\
                        <li><span class=\"code\" translate=\"no\">asXXX()</span> calls are safe since they just return pointers to the data referenced by the handle\n\
                           without worrying about whether they are clean or not (which is also the least common\n\
                           thing to do when reading data). \n\
                        </li>\n\
                        <li><span class=\"code\" translate=\"no\">asGenericXXX()</span> calls are not safe since they use the read/write reference counting to get at <span class=\"code\" translate=\"no\">Tdata</span> information. \n\
                        </li>\n\
                     </ul> \n\
                     <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5574\"></a>The context is important too - if you just have a bunch of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a></span> objects lying around then you have already done the thread-unsafe part of extracting\n\
                        them from the datablock. The first level of danger is that the datablocks may not\n\
                        exist at all yet since they are lazily created so you have to make sure only one thread\n\
                        does that. The second level is when you are getting handles for the purpose of reading\n\
                        data the datablock may trigger an evaluation (if you use the <span class=\"code\" translate=\"no\">inputValue</span>(...) methods) which has its own thread safety issues. \n\
                     </p> \n\
                     <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5573\"></a>The safest algorithm for doing a compute would be: \n\
                     </p> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5572\"></a><ol type=\"1\" start=\"1\">\n\
                        <li>Get all input <span class=\"code\" translate=\"no\">MDataHandles</span>. \n\
                        </li>\n\
                        <li>PARALLEL( Get all input values from unique handles ) </li>\n\
                        <li>Perform the computation (in parallel if possible) </li>\n\
                        <li>PARALLEL( Put all output values into handles ) </li>\n\
                        <li>PARALLEL( Get any output values of interest, in any order, not necessarily unique)\n\
                           \n\
                        </li>\n\
                     </ol> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArrayDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_array_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_array_data_handle.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArrayDataHandle</a></span> \n\
                     <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-556B\"></a>This class maintains internal state since it is effectively a smart pointer into the\n\
                        datablock, so there are obvious dangers in using the same handle in multiple threads.\n\
                        Multiple threads making calls in parallel to <span class=\"code\" translate=\"no\">jumpToElement()</span> followed by query calls will not be threadsafe. \n\
                     </p> \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-556A\"></a> \n\
               <h3><a name=\"GUID-092314A8-D291-4149-A59F-0952FF204B4B\"></a>Non-threadsafe functionality\n\
               </h3> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5569\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnNurbsCurve\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_nurbs_curve.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_nurbs_curve.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNurbsCurve</a></span> evaluation, for example, point on curve computation \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnNurbsSurface\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_nurbs_surface.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_nurbs_surface.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNurbsSurface</a></span> evaluation, for example, point on surface computation \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnSubd\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_subd.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnSubd</a></span> evaluation \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";