var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-3824AD22-F46C-4806-9884-2C6292468762\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Camera information in relation to DirectX and OpenGL draw APIs</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3824AD22-F46C-4806-9884-2C6292468762\"></a><div class=\"head\">\n\
            <h1>Camera information in relation to DirectX and OpenGL draw APIs</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_32BA2CB3DAA0416FBD77862FFD65065E\"></a> \n\
            <h2><a name=\"GUID-3ABE4EAF-7314-43A8-B3C3-E83CD9895BFF\"></a>Conventions\n\
            </h2> \n\
            <p>DirectX and OpenGL have different camera conventions. \n\
               		\n\
            </p> <a name=\"UL_FD23EFEE88464DC88150C701A6BA8731\"></a><ul>\n\
               <li>DirectX uses a left-handed camera coordinate system, where the view direction points\n\
                  down the Z+ axis and the near and far clip planes are mapped to the [0,1]<em class=\"mild\"> normalized device coordinate</em> (NDC) range in the Z axis. \n\
                  		  \n\
               </li>\n\
               <li>OpenGL (and Maya) use a camera right-handed coordinate system. Additionally, the OpenGL\n\
                  view direction points down the Z- axis and the near and far clip planes map to the\n\
                  [-1,1] range in the Z axis. \n\
                  		  \n\
               </li>\n\
            </ul> \n\
            <p>Viewport 2.0 remains consistent with the rest of Maya by using a right-handed coordinate\n\
               system when setting the camera projection matrix. However, the near and far clip planes\n\
               map to the [0,1] range in Z. \n\
               		\n\
            </p> \n\
            <p>Thus, when querying for: \n\
               		\n\
            </p> <a name=\"UL_E6DA316234F449BAABE3A1C3B51DBD94\"></a><ul>\n\
               <li>Depth range using \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext::getDepthRange()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html#ae1bda403fc02486d936aadc56a90e395&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDrawContext::getDepthRange()</a></span>, the return value will be in the [0,1] range for DirectX and OpenGL. \n\
                  		  \n\
               </li>\n\
               <li>View direction using \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext::viewDirectionAlongNegZ()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html#a6913c6eda7d76d313d3ea1a8fab5318d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDrawContext::viewDirectionAlongNegZ()</a></span>, the return value will always indicate that the view direction is along –Z for both\n\
                  OpenGL and DirectX. \n\
                  		  \n\
               </li>\n\
            </ul> \n\
            <p>The world space camera vectors can be queried by passing the \n\
               		  <span class=\"code\" translate=\"no\">kViewDirection</span> (direction), \n\
               		  <span class=\"code\" translate=\"no\">kViewUp</span> (up), and \n\
               		  <span class=\"code\" translate=\"no\">kViewRight</span> (right) enums to the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::getTuple()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#a3a2746b602eb8dd543fa0a74497614d1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFrameContext::getTuple()</a></span> method. These three vectors form the basis of a right-handed coordinate system. \n\
               		\n\
            </p> \n\
            <p><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDrawContext</a></span> also provides access to the active camera. When querying its properties via the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera</a></span> interface, the same consistent camera vector values can be queried. If object space\n\
               vectors are returned, then the values will show a consistent right-handed coordinate\n\
               system with a Z- view direction. \n\
               		\n\
            </p> \n\
            <p>Some useful methods that can be used for querying include: \n\
               		\n\
            </p> <a name=\"UL_1552D8B618764FAFA53B4D2DD1603EC4\"></a><ul>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::unnormalizedNearClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a1329b457d65a26bac707a26908cbc5d4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera::unnormalizedNearClippingPlane()</a></span>. This returns values in object or world space, and not NDC. \n\
                  		  \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::unnormalizedFarClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#af6f43d59313ce37fe5e8bf75f67d6374&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera::unnormalizedFarClippingPlane()</a></span>. This returns values in object or world space, and not NDC. \n\
                  		  \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::eyePoint()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a578aa1d086c52784f1c5e7b204f70a9d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera::eyePoint()</a></span>. If querying world space coordinates, this is equivalent to querying \n\
                  			 <span class=\"code\" translate=\"no\">kViewPosition</span>. \n\
                  		  \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::viewDirection()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a8607e1142843f35474557b5daa9489de&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera::viewDirection()</a></span>. If querying world space coordinates, this is equivalent to querying \n\
                  			 <span class=\"code\" translate=\"no\">kViewDirection</span>. \n\
                  		  \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::upDirection()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a02c40747377d923d863cc514ef0b4d3d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera::upDirection()</a></span>. If querying world space coordinates, this is equivalent to querying \n\
                  			 <span class=\"code\" translate=\"no\">kViewUp</span>. \n\
                  		  \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::rightDirection()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a12417c673de907852f1d2917106b6097&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera::rightDirection()</a></span>. If querying world space coordinates, this is equivalent to querying \n\
                  			 <span class=\"code\" translate=\"no\">kViewRight</span>. \n\
                  		  \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_C2DB49716BC44CB89F13991933D78016\"></a> \n\
            <h2><a name=\"GUID-5664999C-04E3-4763-8312-B4FCAF5FD545\"></a>Clipping planes\n\
            </h2> \n\
            <p>With the Legacy Default Viewport (Viewport 1), it is possible to directly set supplemental\n\
               clip planes in OpenGL when the active camera belongs to a camera set. \n\
               		\n\
            </p> \n\
            <p>With Viewport 2.0, it is not advisable to directly query the device, as fixed-function\n\
               user clip planes may not be available for certain draw APIs. As such, the Viewport\n\
               1 behaviour is disabled by default for Viewport 2.0, though it can be accessed via\n\
               an environment variable if needed when running OpenGL (ENABLE_DEFAULT_VIEWPORT_CAMERA_SETS).\n\
               \n\
               		\n\
            </p> \n\
            <p>A draw API agnostic option to get world space clip planes is shown below. The camera\n\
               is taken from the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDrawContext</a></span>, but can be for any camera shape. Note the use of the \n\
               		  <em class=\"mild\">unnormalized</em> methods to query clip planes. \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">MDrawContext context;\n\
\n\
// Get the current camera from the context\n\
<a href=\"javascript:void(0)\" data-symbol=\"MFnCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera</a> activeCamera(context.getCurrentCameraPath());\n\
\n\
// Get relative near and far clip values with respect to the camera position\n\
// You should ignore any override values set when using a\n\
// camera set; therefore, do not use the nearClippingPlane() and farClippingPlane() \n\
// methods on MFnCamera.\n\
double nearD = activeCamera.<em class=\"codeEmphasisStrong\">unnormalizedNearClippingPlane</em>();\n\
double farD = activeCamera.<em class=\"codeEmphasisStrong\">unnormalizedFarClippingPlane</em>();\n\
\n\
// Get world space camera information\n\
<a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPoint</a> eyePoint = activeCamera.eyePoint(<a href=\"javascript:void(0)\" data-symbol=\"MSpace::kWorld\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_space.html#ab11a1dda34491acff014ddfc9e6bafb8a45a60f04ac9114f0d6e865a6285f40b2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSpace::kWorld</a>);\n\
<a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVector</a> viewDirection = activeCamera.viewDirection(<a href=\"javascript:void(0)\" data-symbol=\"MSpace::kWorld\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_space.html#ab11a1dda34491acff014ddfc9e6bafb8a45a60f04ac9114f0d6e865a6285f40b2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSpace::kWorld</a>); // Positive value\n\
\n\
double dist = eyePoint[0]*viewDirection[0] + \n\
              eyePoint[1]*viewDirection[1] + \n\
              eyePoint[2]*viewDirection[2]; \n\
\n\
// Compute near clip plane facing away from the camera direction (for OpenGL)\n\
double distNear = -1.0 * (dist + nearD); \n\
<a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVector</a> OpenGL_NearClipPlaneVector( 	\n\
       viewDirection[0], viewDirection[1], viewDirection[2], distNear);\n\
\n\
// Compute far clip plane facing towards the camera direction (for OpenGL)\n\
double distFar = dist + farD;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVector</a> OpenGL_FarClipPlaneVector(\n\
       -viewDirection[0], -viewDirection[1], -viewDirection[2], distFar);</pre></div> \n\
            <p>The equivalent code if only using \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDrawContext</a></span> would be as follows: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">// Query the camera coordinate system\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_double_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDoubleArray</a> vPos = context.getTuple(<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MFrameContext::kViewPosition\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670aba1d4dab9b951b21263efade0a8f6729&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MFrameContext::kViewPosition</a>);\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_double_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDoubleArray</a> vDir = context.getTuple(<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MFrameContext::kViewDirection\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670a227b592bc3c59e5855866b1d9f8c997b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MFrameContext::kViewDirection</a>);\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_double_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDoubleArray</a> vNear = context.getTuple(<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MFrameContext::kViewUnnormlizedNearClipValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670ab2b11196237108d7c893c6940cfe4b16&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MFrameContext::kViewUnnormlizedNearClipValue</a>);\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_double_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDoubleArray</a> vFar = context.getTuple(<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MFrameContext::kViewUnnormalizedFarClipValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670a973730135c8d1f08c5de00aa2997e914&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MFrameContext::kViewUnnormalizedFarClipValue</a>);\n\
\n\
// Compute the world space planes for the near and far clip planes\n\
// The near plane is pointing away from the camera and is thus pointing in the\n\
// negative direction, while the far plane is pointing towards the camera (positive \n\
// direction.\n\
double distW = vPos[0]*vDir[0] + \n\
               vPos[1]*vDir[1] + \n\
               vPos[2]*vDir[2]; \n\
\n\
// Near clip plane faces away from the camera\n\
double distNearW = -1.0 * (distW + vNear[0]); \n\
<a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVector</a> OpenGL_NearPlane(vDir[0], vDir[1], vDir[2], distNearW);\n\
\n\
// Far clip plane faces torwards the camera\n\
double distFarW = distW + vFar[0];\n\
<a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVector</a> OpenGL_NearPlane(-vDir[0], -vDir[1], -vDir[2], distFarW);	</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_AC489B849E7445E59CA4334566820C3F\"></a> \n\
            <h2><a name=\"GUID-D8E02915-60E0-4BA0-A2AC-B753B62F9F11\"></a>Depth Priority\n\
            </h2> \n\
            <p>Shaders may use depth priority to offset the geometric position along the view direction.\n\
               Within the shader code, the computation is relative to the actual device’s depth range,\n\
               and thus differ for OpenGL versus DirectX. Assuming a uniform parameter called \n\
               		  <span class=\"code\" translate=\"no\">depthPriority</span> has been set appropriately, the following sample code performs the offset in DirectX\n\
               and OpenGL: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">// DX range is [0,1] or 1 in size.\n\
float4 iPcPriority( float3 pm, float depthPriority, float4x4 worldViewProjectionC )\n\
{ \n\
    float4 P = mul( float4(pm,1), worldViewProjectionC ); \n\
    P.z -= P.w * depthPriority; \n\
    return P; \n\
}\n\
 \n\
// OpenGL range is [-1,1] or 2 in size\n\
vec4 iPcPriority( vec3 pm, float depthPriority, mat4 worldViewProjectionC )\n\
{\n\
    vec4 P = worldViewProjectionC * vec4(pm,1.0f);\n\
    P.z -= P.w * <em class=\"codeEmphasisStrong\">2.0</em> * depthPriority;\n\
    return P;\n\
}</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_89AF554538A6474DB3C4DBE6BF8EC25D\"></a> \n\
            <h2><a name=\"GUID-856CBF5F-82FB-48D5-82DA-54FD4DE91886\"></a>Selection\n\
            </h2> \n\
            <p>Selection uses the same information as is used for drawing. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_F0D6EC42E0F841C4A8E10AFE78E08DC2\"></a> \n\
            <h2><a name=\"GUID-C19F6761-D4EE-4171-A8DC-6F0D0997EA95\"></a>Screen Orientation\n\
            </h2> \n\
            <p>It is worth noting that, for fat lines and points (generated using geometry shaders),\n\
               or any screen aligned geometry, that a counter-clockwise winding order indicates front-facing\n\
               geometry. This is consistent for both DirectX and OpenGL. \n\
               		\n\
            </p> \n\
            <p>For example, in the following DirectX code, the quad points are defined as follows:\n\
               \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">static const float4 <em class=\"codeEmphasisStrong\">cQuadPts</em>[4] = {  \n\
    float4( -1.0,  1.0, 0, 0 ),  \n\
    float4( -1.0, -1.0, 0, 0 ),  \n\
    float4(  1.0,  1.0, 0, 0 ),  \n\
    float4(  1.0, -1.0, 0, 0 )};</pre></div> \n\
            <p>The geometry shader expansion traverses through the points in forward order, resulting\n\
               in a triangle strip with the triangles each having a counter-clockwise orientation:\n\
               \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">void point2ScreenQuad( geometryInS inputs[1], float2 pointSz, float2 screenSize,\n\
     float4x4 viewProjInverse, float depthPriorityUnit, bool orthographic, float DPThresholdInView, \n\
     inout TriangleStream&lt;geometryInS&gt; outStream  ) \n\
{\n\
    geometryInS outS  = inputs[0]; \n\
    float size = max(0, max(pointSz.x, pointSz.y)); \n\
    float dpScale = orthographic ? 1.0f : -DPThresholdInView; \n\
    float dp = 2.0f * size * cDepthPriorityUnit * dpScale; \n\
    float4 sizeInZ = float4(pointSz.xy  / screenSize.xy, 0, 0) * outS.Pc.w;  \n\
    [unroll] for( int <em class=\"codeEmphasisStrong\">i = 0; i &lt; 4; ++i</em> ) { \n\
        outS.Pc = inputs[0].Pc + sizeInZ * <em class=\"codeEmphasisStrong\">cQuadPts</em>[i]; \n\
        outS.Pc.z = inputs[0].Pc.z - dp; \n\
        <em class=\"codeEmphasisStrong\">outStream.Append( outS )</em>; \n\
    } \n\
    outStream.RestartStrip(); \n\
}</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_2C3C869B07AB45B4AD8F88049344E5B9\"></a> \n\
            <h2><a name=\"GUID-329A9C67-D91C-4FEC-BAD4-5592D6CC7F43\"></a>Examples\n\
            </h2> <a name=\"UL_439D1F2236164648AB73B52E51EDD848\"></a><ul>\n\
               <li> The plug-in \n\
                  			 <em class=\"mild\">rawFootPrintNode</em> in the Maya Developer Kit has example debug code that performs various \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDrawContext</a></span>/<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFrameContext</a></span> and \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera</a></span> queries, including the world space clip plane computation described above. \n\
                  		  \n\
               </li>\n\
               <li>The \n\
                  			 <em class=\"mild\">cgfxShader</em> plug-in shows an example of converting from normalized device coordinates (NDC) to\n\
                  screen space. \n\
                  		  \n\
               </li>\n\
               <li>The \n\
                  			 <span class=\"code\" translate=\"no\">MayaBlinnDirectionalLightShadowGL.cgfx</span>, \n\
                  			 <span class=\"code\" translate=\"no\">MayaBlinnDirectionalLightShadowGL.ogsfx</span>, and \n\
                  			 <span class=\"code\" translate=\"no\">MayaBlinnDirectionalLightShadow10.fx</span> files provide DirectX and OpenGL sample implementations of using depth priority offsets\n\
                  for the same shader. See the \n\
                  			 <span class=\"code\" translate=\"no\">bin\\Cg</span>, \n\
                  			 <span class=\"code\" translate=\"no\">bin\\OGSFX</span> and \n\
                  			 <span class=\"code\" translate=\"no\">bin\\HLSL</span> folders of the Maya installation directory for these files. The fragment \n\
                  			 <span class=\"code\" translate=\"no\">mayaDepthPriorityShader</span> can also be examined as it is the \n\
                  			 <span class=\"code\" translate=\"no\">iPcPriority</span> function discussed above. \n\
                  		  \n\
               </li>\n\
               <li>The \n\
                  			 <span class=\"code\" translate=\"no\">mayaPoint2Quad</span> fragment can be examined for an example of geometry shader code used for drawing\n\
                  fat lines in the \n\
                  			 <span class=\"code\" translate=\"no\">mayaFatPointShader</span>. It also incorporates the \n\
                  			 <span class=\"code\" translate=\"no\">mayaDepthPriorityShader</span> fragment to allow view direction offsets. \n\
                  		  \n\
               </li>\n\
            </ul> \n\
            <div><a name=\"GUID-2B8C80C9-1974-4D02-815E-86D46EF05FFE\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n\
                  <p>Fragments can be examined using either of the following methods: \n\
                     		  \n\
                  </p> <a name=\"UL_19900E8E87F54C62A472CF9DB002C076\"></a><ul>\n\
                     <li>the \n\
                        				<span class=\"code\" translate=\"no\">ogs –xml &lt;fragmentName&gt;</span> command with the fragment name as the \n\
                        				<span class=\"code\" translate=\"no\">&lt;fragmentname&gt;</span> argument \n\
                        			 \n\
                     </li>\n\
                     <li>via \n\
                        				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFragmentManager::getFragmentXML()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_fragment_manager.html#ac6fb2a8f6c193bf89911f036035cc355&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFragmentManager::getFragmentXML()</a></span> API interface. The \n\
                        				<em class=\"mild\">fragmentDumper</em> sample plug-in implements the \n\
                        				<span class=\"code\" translate=\"no\">dumpFragment</span> command which can also be used to examine fragments using the \n\
                        				<span class=\"code\" translate=\"no\">-fn</span> option. \n\
                        			 \n\
                     </li>\n\
                  </ul> \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";