var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-6031DE26-93CE-445A-AED9-C27C659268E5\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Example: Creating an IK Joint Chain</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6031DE26-93CE-445A-AED9-C27C659268E5\"></a><div class=\"head\">\n\
            <h1>Example: Creating an IK Joint Chain</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_020B1FF07E4644C19FED399551D2D044\"></a> \n\
            <h2><a name=\"GUID-4E388EE0-4E5A-4779-81AE-A95DE741F4D4\"></a>Example: Creating an Inverse Kinematic Joint Chain\n\
            </h2> \n\
            <p><a name=\"GUID-E0D39C9E-B6A7-48A2-B9D8-7DE976C623D4\"></a> <em class=\"strong\">Filename:</em> <span class=\"code\" translate=\"no\">jointChain.py</span> \n\
            </p> \n\
            <p><a name=\"GUID-EB56D0B6-C17D-4472-8D66-F89FF3364390\"></a> <em class=\"strong\">Sample Output:</em> \n\
            </p> \n\
            <p><a name=\"GUID-890A40D5-BB17-48DE-8556-4350B361C051\"></a></p> <img src=\"images/GUID-C86DFECE-8888-4E05-A9A6-C71D2333C169-low.png\"> \n\
            <p><a name=\"GUID-847DDA69-90A4-4F6E-A8D6-AD5D547481B9\"></a><em class=\"strong\">Program Summary:</em> The plug-in code below creates a new command which takes one argument, \"<span class=\"code\" translate=\"no\">length</span>\", to define the number of joints in an inverse kinematic joint chain, for example:\n\
               <span class=\"code\" translate=\"no\">cmds.myJointChain(length=4)</span>. The joint chain is created in an arc, at the end of which is placed an inverse kinematic\n\
               (IK) effector coupled with an IK handle. The IK handle allows the user to manipulate\n\
               the entire joint chain using only the IK effector. When the IK effector moves, it\n\
               causes the rest of the joints to move while maintaining their constrained orientations\n\
               towards one another. \n\
            </p> \n\
            <div><a name=\"GUID-C5761B71-40E3-45D0-899A-CAD15286B087\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Observe that we use <span class=\"code\" translate=\"no\">MDagModifier.commandToExecute()</span> to facilitate the creation of our inverse kinematic handle. The MEL command reference\n\
                  can be found under <em class=\"strong\">Maya User Guide &gt; Technical Documentation &gt; Commands</em>. \n\
               </div>\n\
            </div> \n\
            <div><a name=\"GUID-44EBFDFC-35A4-4987-95FC-CEF227395F13\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This sample plug-in script uses <span class=\"code\" translate=\"no\">OpenMayaAnim.MFnIkJoint()</span>, which is not exposed in the Maya Python API 2.0. Therefore, there is no 2.0 version\n\
                  of this sample plug-in. \n\
               </div>\n\
            </div> <a name=\"SECTION_B5DCFBB9A15D4D0C817E42AA240DEB60\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-F6E7235B-CEED-41E1-BFB8-8B75764B89A5\"></a><span class=\"collapsible-section-title\">Python API 1.0:</span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><a name=\"LANG-PY\"></a><pre class=\"prettyprint lang-py\"># jointChain.py\n\
\n\
import sys\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMayaAnim as OpenMayaAnim\n\
\n\
kPluginCmdName = \'myJointChain\'\n\
\n\
# The length of the chain.\n\
kLengthFlag = \'-l\'\n\
kLengthLongFlag = \'-length\'\n\
defaultLength = 3\n\
\n\
jointDistance = 5     # the distance between two joints\n\
jointOrientation = 20 # degrees.\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class JointChainCommand(OpenMayaMPx.MPxCommand):\n\
    \n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    \n\
    def parseArgs(self, pArguments):\n\
        \'\'\' Parses the command\'s arguments. \'\'\'\n\
        \n\
        # Set the default chain length in case there are no arguments.\n\
        global defaultLength\n\
        self.length = defaultLength\n\
        \n\
        # Obtain the flag value, if the flag is set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), pArguments )\n\
        if argData.isFlagSet( kLengthFlag ):\n\
            \n\
            # Get the value associated with the flag as an integer.\n\
            flagValue = argData.flagArgumentInt( kLengthFlag, 0 )\n\
            \n\
            # Make sure this value is larger than the default length.\n\
            if flagValue &gt; defaultLength:\n\
                self.length = flagValue\n\
    \n\
    \n\
    def doIt(self, pArguments):\n\
        \'\'\' Command Execution. \'\'\'\n\
        \n\
        # Parse the passed arguments.\n\
        self.parseArgs( pArguments )\n\
        \n\
        # Create an instance of an <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> to keep track of the created objects,\n\
        # and to undo their creation in our undoIt() function.\n\
        self.dagModifier = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagModifier</a>()\n\
        \n\
        # Create the joint MObjects we will be manipulating.\n\
        self.jointObjects = []\n\
        for i in range(0, self.length):\n\
            if i == 0:\n\
                # The first joint has no parent.\n\
                newJointObj = self.dagModifier.createNode( \'joint\' )\n\
            else:\n\
                # Assign the new joint as a child to the previous joint.\n\
                newJointObj = self.dagModifier.createNode( \'joint\', self.jointObjects[i-1] )\n\
            # Keep track of all the joints created.\n\
            self.jointObjects.append( newJointObj )\n\
        \n\
        # Create the inverse kinematic effector MObject. The effector is a child of the last joint object.\n\
        # The [-1] index is a Python-specific way of referring to the last item in a list.\n\
        self.effectorObj = self.dagModifier.createNode( \'ikEffector\', self.jointObjects[-1] )\n\
        \n\
        # Invoke the command\'s redoIt() function to actually create and manipulate these objects.\n\
        self.redoIt()\n\
        \n\
    \n\
    def redoIt(self):\n\
        \'\'\' Create and manipulate the nodes to form the joint chain. \'\'\'\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier.\n\
        self.dagModifier.doIt()\n\
        \n\
        #=======================================\n\
        # JOINT MANIPULATION\n\
        #=======================================\n\
        # We can now use the function sets on the newly created DAG objects.\n\
        jointFn = OpenMayaAnim.MFnIkJoint()\n\
        \n\
        for i in range( 1, len( self.jointObjects ) ):\n\
\n\
            jointFn.setObject( self.jointObjects[i] )\n\
            # We set the orientation for our joint to be \'jointOrientation\' degrees, to form an arc. \n\
            # We use MFnIkJoint.setOrientation() instead of MFnTransform.setRotation() to let the\n\
            # inverse-kinematic handle maintain the curvature.\n\
            global jointOrientation\n\
            rotationAngle = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MAngle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_angle.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MAngle</a>( jointOrientation, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MAngle.kDegrees\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_angle.html#a934f121109da8c565d519db181690194&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MAngle.kDegrees</a> )\n\
            jointFn.setOrientation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MEulerRotation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_euler_rotation.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MEulerRotation</a>( rotationAngle.asRadians(), 0 , 0, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MEulerRotation.kXYZ\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_euler_rotation.html#a6e71b00d51c29a230e7ccc90bd61f06e&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MEulerRotation.kXYZ</a> ) )\n\
            \n\
            # We translate the joint by \'jointDistance\' units along its parent\'s y axis.\n\
            global jointDistance\n\
            translationVector = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, jointDistance, 0 )\n\
            jointFn.setTranslation( translationVector, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
\n\
        #=======================================\n\
        # IK HANDLE MANIPULATION\n\
        #=======================================\n\
        # We will use the MEL command \'ikHandle\' to create the handle which will move our joint chain. This command\n\
        # will be enqueued in our reference to the <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> so that it can be undone in our call to MDagModifier.undoIt().\n\
        \n\
        # Obtain the DAG path of the first joint.\n\
        startJointDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        jointFn.setObject( self.jointObjects[0] )\n\
        jointFn.getPath( startJointDagPath )\n\
             \n\
        # Obtain the DAG path of the effector.\n\
        effectorDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        effectorFn = OpenMayaAnim.MFnIkEffector( self.effectorObj )\n\
        effectorFn.getPath( effectorDagPath )\n\
        \n\
        # Enqueue the following MEL command with the DAG paths of the start joint and the end effector.\n\
        self.dagModifier.commandToExecute( \'ikHandle -sj \' + startJointDagPath.fullPathName() + \' -ee \' + effectorDagPath.fullPathName() )\n\
        \n\
        # We call MDagModifier.doIt() to effectively execute the MEL command and create the ikHandle. \n\
        self.dagModifier.doIt()\n\
        \n\
    \n\
    def undoIt(self):\n\
        \'\'\' Undo the command. \'\'\'\n\
        # This call to MDagModifier.undoIt() undoes all the operations within the MDagModifier.\n\
        # Observe that the number of calls to MDagModifier.undoIt() does not need to match the number of calls to MDagModifier.doIt().\n\
        self.dagModifier.undoIt()\n\
        \n\
        \n\
    def isUndoable(self):\n\
        \'\'\' This function must return True to indicate that it is undoable. \'\'\' \n\
        return True\n\
        \n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Creates an instance of the command. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( JointChainCommand() )\n\
\n\
def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    syntax.addFlag( kLengthFlag, kLengthLongFlag, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> )\n\
    return syntax\n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initializes the plug-in. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
        raise\n\
    \n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitializes the plug-in. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
        raise\n\
\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'jointChain.py\' )\n\
cmds.myJointChain( length=4 )\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";