var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-699ED73F-5898-4E4F-A9E5-35A7C30EFA91\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Differences between the Maya .NET API and the Maya C++ API</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-699ED73F-5898-4E4F-A9E5-35A7C30EFA91\"></a><div class=\"head\">\n\
            <h1>Differences between the Maya .NET API and the Maya C++ API</h1>\n\
         </div>\n\
         <p><a name=\"GUID-9000ED43-7246-460A-93A0-AA181CD4F455\"></a>The primary differences between the Maya .NET API and the Maya C++ API are: \n\
         </p><a name=\"UL_325C87415B254B6FAE4EB2608B286A26\"></a><ul>\n\
            <li><em class=\"strong\">Properties instead of getters and setters</em> – Many of the getter and setter functions in the C++ API have been mapped to C# properties.\n\
               For instance, the methods <span class=\"code\" translate=\"no\">isInstanceable</span> and <span class=\"code\" translate=\"no\">setInstanceable</span> of the class <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a></span> are now exposed as a C# property called <span class=\"code\" translate=\"no\">isInstanceable</span> (with get and set accessors). \n\
               <p><a name=\"GUID-BB77D64F-DBEE-4C8B-B1A4-58838632341F\"></a>Getter functions are functions that return a value, have no arguments, and that have\n\
                  no observable effect on the state of the application. Getter function names start\n\
                  with the prefix get, is, has, or can; or are qualified as a “const” function in the\n\
                  C++ header files. Setter functions are void functions that have a single argument,\n\
                  start with the prefix set, and that have the same root name as a getter function.\n\
                  Getter functions with a corresponding setter function (same root name) are mapped\n\
                  to read-write properties; otherwise, they are mapped to read-only properties. Properties\n\
                  have the same name as the getter function but with the prefix removed. \n\
               </p> \n\
               <p><a name=\"GUID-1DFC3FDE-9FFC-433D-B1B3-853B7DFC264D\"></a>In certain cases, the names of the properties had to be changed because the new property\n\
                  name conflicted with an existing method name. The word <span class=\"code\" translate=\"no\">Property</span> was added to the new property name. For example, <span class=\"code\" translate=\"no\">index()</span> became <span class=\"code\" translate=\"no\">indexProperty</span>. \n\
               </p> \n\
               <p><a name=\"GUID-ADC0B1E9-F7C3-47ED-BE86-FCFDBA6E6E7B\"></a> For more information regarding C# properties, see MSDN at <a href=\"http://msdn.microsoft.com/en-us/default.aspx\" target=\"_blank\">http://msdn.microsoft.com/en-us/default.aspx</a> and <a href=\"http://msdn.microsoft.com/en-us/library/x9fsa0sw%28v=vs.100%29.aspx\" target=\"_blank\">C# properties</a>. \n\
               </p> \n\
            </li>\n\
            <li><em class=\"strong\">Events instead of function pointers</em> – The C# event pattern replaces the message registration mechanism of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMessage\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_message.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_message.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMessage</a></span> derived classes (for example, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSceneMessage\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_scene_message.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_scene_message.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSceneMessage</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MNodeMessage\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_node_message.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_node_message.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MNodeMessage</a></span>, and so forth). Therefore, you can register or unregister your callbacks by simply\n\
               adding or removing them to/from the corresponding event handler of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMessage\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_message.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_message.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMessage</a></span> derived class. \n\
               <p><a name=\"GUID-1BBFDC9F-94D2-415E-AC17-E04A3C1342BB\"></a>For instance, do <span class=\"code\" translate=\"no\">MDagMessage.ParentAddedEvent += callback</span> instead of <span class=\"code\" translate=\"no\">MDagMessage::addParentAddedCallback(callback)</span>. \n\
               </p> \n\
               <p><a name=\"GUID-12BE2BE5-5BBA-4B3F-83BA-F5208BB1A76E\"></a>For the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSceneMessage\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_scene_message.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_scene_message.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSceneMessage</a></span> class, each message identified by a value of the enum <span class=\"code\" translate=\"no\">Message</span> now has an independent event handler; therefore, the enum is no longer meaningful.\n\
                  For instance, do <span class=\"code\" translate=\"no\">MSceneMessage.SceneUpdate += callback</span> instead of <span class=\"code\" translate=\"no\">MSceneMessage::addCallback( <a href=\"javascript:void(0)\" data-symbol=\"MSceneMessage::kSceneUpdate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_scene_message.html#a4f09127c805cc1f5ee20e67db7b45efaa3fed96219df72e729d0b7049c4754927&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSceneMessage::kSceneUpdate</a>, callback )</span>. \n\
               </p> \n\
               <p><a name=\"GUID-AB7ECC59-8CB3-48D2-9B3D-F85671389F9E\"></a>For callbacks related to an instance of an object (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span>, and so forth), the event handler can be found directly in the class of that object.\n\
                  For instance, do <span class=\"code\" translate=\"no\">obj.NodeAddedToModel += callback</span> (with <span class=\"code\" translate=\"no\">obj</span> of type <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span>) instead of <span class=\"code\" translate=\"no\">MModelMessage::addNodeAddedToModelCallback(obj, callback)</span>. \n\
               </p> \n\
               <p><a name=\"GUID-E119AAC6-29BF-4FEA-9B2E-71993D4B1DDD\"></a>To avoid memory leaks, you must deregister your callbacks (by removing them from the\n\
                  corresponding event handler) when the callbacks are no longer needed. A new mechanism\n\
                  has been added to automatically deregister the callbacks when the plug-in is unloaded\n\
                  from Maya. \n\
               </p> \n\
               <p><a name=\"GUID-52539F75-C1F8-45E4-93E9-D9DC06FA3250\"></a>To see how events are used, refer to the <span class=\"code\" translate=\"no\">pluginCallbacks</span> example in the <span class=\"code\" translate=\"no\">devkit\\dotnet\\examples</span> folder of your Developer Kit installation. For more information on C# events see\n\
                  <a href=\"http://msdn.microsoft.com/en-us/library/awbftdfh%28v=vs.100%29.aspx\" target=\"_blank\">C# events</a> in MSDN. \n\
               </p> \n\
            </li>\n\
            <li><em class=\"strong\">Exceptions instead of MStatus failure codes</em> – In case of failure or exceptional cases, a plug-in should raise an exception instead\n\
               of returning an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a></span>. With this pattern adopted, most functions of the SDK return <span class=\"code\" translate=\"no\">void</span> instead of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a></span>, which does not exist in the C# SDK. The only exceptions to this rule are those methods\n\
               that must return information to Maya that did so via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a></span> in C++. For more information, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-4680D9EE-A9A7-4735-A539-22D9EE36EEC5.htm\">Removal of MStatus return codes from .NET API</a></span>. \n\
            </li>\n\
            <li> \n\
               <p><a name=\"GUID-FABFA969-736F-4F4C-87DD-7A58042C78FF\"></a><em class=\"strong\">Usage of IEnumerable&lt;T&gt;</em> – Iterators support <span class=\"code\" translate=\"no\">IEnumerable&lt;T&gt;</span>, which facilitates the usage of LINQ. For more information on <span class=\"code\" translate=\"no\">IEnumerable</span>, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-5F3F9272-0968-4AAD-8F0E-A54230E664A3.htm\">Using IEnumerable and LINQ with the Maya .NET API</a></span> and <a href=\"http://msdn.microsoft.com/en-us/library/system.collections.ienumerable%28v=vs.100%29.aspx\" target=\"_blank\">IEnumerable Interface</a> in MSDN. \n\
               </p> \n\
            </li>\n\
            <li><em class=\"strong\">Support for .NET collections</em> – Specialized collection classes in the Maya API (such as <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPointArray</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_int_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MIntArray</a></span>, and so forth) support the C# interfaces <span class=\"code\" translate=\"no\">IEnumerable</span> and <span class=\"code\" translate=\"no\">IList</span>. In addition, they have constructors that accept a C# array and a method that returns\n\
               a C# array. For more information on C# arrays, see <a href=\"http://msdn.microsoft.com/en-us/library/9b9dty7d%28v=vs.100%29.aspx\" target=\"_blank\">Arrays</a> in MSDN. \n\
            </li>\n\
            <li><em class=\"strong\">No OpenMayaFx classes</em> – The classes from the OpenMayaFX module have not been ported to the .NET Maya API.\n\
               \n\
            </li>\n\
            <li><em class=\"strong\">MDockStation</em> – This is a new class defined to facilitate docking of WPF windows within the Maya\n\
               UI. In addition, with <span class=\"code\" translate=\"no\">MDockStation</span>, you can also embed any HWND in Maya (not only WPF\'s, but for example, a WF window).\n\
               For more information on WPF controls, see <a href=\"http://msdn.microsoft.com/en-us/library/aa970268%28v=vs.100%29.aspx\" target=\"_blank\">Introduction to WPF</a> in MSDN. \n\
            </li>\n\
         </ul>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";