var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-856DDB26-93E7-493D-A1D4-60C4CBA38B9C\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Maya Python Plug-in Learning Path</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-856DDB26-93E7-493D-A1D4-60C4CBA38B9C\"></a><div class=\"head\">\n\
            <h1>Maya Python Plug-in Learning Path</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_99F5AD4CABFB4B24AA0E1DD1EEAE73F1\"></a> \n\
            <h2><a name=\"GUID-9F445B21-D563-4F9D-AF97-DCBB9F8AF16C\"></a>Welcome!\n\
            </h2> \n\
            <p><a name=\"GUID-9DD0E1E7-8B1C-4CFE-B886-BD0B93C492F7\"></a> This Learning Path aims to outline the important concepts, classes, and functions\n\
               used to develop Maya plug-ins with Python. We recommend reading the topics in this\n\
               Learning Path in sequential order, however the annotated code samples can be consulted\n\
               independently as reference material. \n\
            </p> \n\
            <div><a name=\"GUID-7B138AC7-667F-452C-A718-FF194712CB7A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This learning path uses both the Maya Python 1.0 and 2.0 APIs. The 2.0 API is faster\n\
                  and more \"Pythonic\", though not all features from 1.0 are available yet in 2.0. For\n\
                  details on the differences between this API and the legacy 1.0 API, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-AC9B3C66-90FE-493F-A7B2-44ABBA77CED2.htm#GUID-F50B96F0-A977-42AE-A500-5589BB7FC878\">Maya Python API 2.0.</a></span> \n\
               </div>\n\
            </div> \n\
            <p><a name=\"GUID-82C243CB-9929-4189-B92E-C830501B3732\"></a></p> <img src=\"images/GUID-ACA58973-3890-4A5D-AC50-E277B69B9472-low.png\"> \n\
            <p><a name=\"GUID-A962882F-27E6-4386-A5AD-8AF8E4E90772\"></a> <em class=\"mild\">\"<span class=\"char_link\"><a href=\"#!/url=./files/GUID-767D6572-552D-4D94-90E2-AE626F276D37.htm\">Now with 100% more voxels!</a></span>\"</em> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_F237414F88C443F7B914D97646240C7D\"></a> \n\
            <h2><a name=\"GUID-24A19A67-CE94-4722-BB7A-FFA7ECA309A6\"></a>Python Scripts and Python Plug-ins - What\'s the Difference?\n\
            </h2> \n\
            <p><a name=\"GUID-1E2A662A-E19E-41F7-85CF-09BB2F69C445\"></a>To begin, an important distinction should be made here between Python <em class=\"strong\">scripts</em> and <em class=\"strong\">plug-ins</em> for Maya: \n\
            </p> <a name=\"UL_3AFB5BD1463E4E109608488CC476004B\"></a><ul>\n\
               <li><em class=\"strong\">Python scripts</em> - These programs can be executed in Maya\'s interactive Script Editor window. Python\n\
                  scripts generally make extensive use of the <span class=\"code\" translate=\"no\">maya.cmds</span> module, whose functionality emulates the majority of Maya\'s MEL commands. The import\n\
                  statement below is typically found at the head of Maya Python scripts. \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds</pre></div> In this learning path, we will use the <span class=\"code\" translate=\"no\">maya.cmds</span> module to execute our Python plug-ins. \n\
                  <div><a name=\"GUID-818B1932-0B20-4467-B9AD-4F0632D09A53\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>For more information on the <span class=\"code\" translate=\"no\">maya.cmds</span> Python module, consult <em class=\"strong\">Maya User Guide &gt; Technical Documentation &gt; CommandsPython</em>. \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
               <li><em class=\"strong\">Python plug-ins</em> - These programs are loaded by Maya\'s Plug-in Manager from <span class=\"code\" translate=\"no\">C:\\Users\\&lt;username&gt;\\Documents\\maya\\&lt;version&gt;\\plug-ins</span>, and from the directories defined in the <span class=\"code\" translate=\"no\">MAYA_PLUG_IN_PATH</span> environment variable. Maya Python plug-ins can be used to define your own commands,\n\
                  nodes, shaders, constraints, file translators, and deformers to name but a few customizable\n\
                  elements. Python plug-ins for Maya make use of several <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"OpenMaya\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya</a></span> modules, which are based on Maya\'s C++ API. \n\
                  <p><a name=\"GUID-7A70A1C2-6F58-4B3D-8CC1-44CEDB75CC56\"></a>2.0: \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.api.OpenMaya       as OpenMaya        # Common classes\n\
import maya.api.OpenMayaAnim   as OpenMayaAnim    # Animation classes\n\
import maya.api.OpenMayaRender as OpenMayaRender  # Rendering classes\n\
import maya.api.OpenMayaUI     as OpenMayaUI      # User interface classes\n\
</pre></div> \n\
                  <p><a name=\"GUID-20BE39F6-8658-4325-ABF2-8481B1CDDC7E\"></a>1.0: \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.OpenMaya       as OpenMaya        # Common classes\n\
import maya.OpenMayaMPx    as OpenMayaMPx     # Classes from which to inherit\n\
import maya.OpenMayaAnim   as OpenMayaAnim    # Animation classes\n\
import maya.OpenMayaFX     as OpenMayaFX      # Effect classes (hair, particles, fluids)\n\
import maya.OpenMayaRender as OpenMayaRender  # Rendering classes\n\
import maya.OpenMayaUI     as OpenMayaUI      # User interface classes\n\
import maya.OpenMayaCloth  as OpenMayaCloth   # Cloth classes</pre></div> \n\
               </li>\n\
            </ul> \n\
         </div><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-FE0662C0-4F1A-46BE-9828-76656C2BD2E2.htm\">Quick Python Syntax Tips</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-B968733D-B288-4DAF-9685-4676DC3E4E94.htm\">Your First Maya Python Plug-in</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-A9FA6DEF-4E48-45A7-AC65-A69E8A55F62D.htm\">Command Plug-in Basics</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-A9070270-9B5D-4511-8012-BC948149884D.htm\">Dependency Graph Plug-in Basics</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";