var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-907A4BEE-41DD-4287-AB23-732332F048C6\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Deformers in the Dependency Graph</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-907A4BEE-41DD-4287-AB23-732332F048C6\"></a><div class=\"head\">\n\
            <h1>Deformers in the Dependency Graph</h1>\n\
         </div>\n\
         <p><a name=\"GUID-FA8DA17C-542A-4920-A413-2C7EBF39EEDA\"></a>Deformers are placed in the construction history of a shape that is being deformed.\n\
            The following figure shows a typical dependency graph including the deformers. <a name=\"FIG_3B9FC06DCCFA48CCA6C02668C974D0FD\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-D25E4847-0C3E-4C49-A144-313437DA7B88-low.png\"></div> \n\
         </p>\n\
         <p><a name=\"GUID-A80CC1BF-D30F-4297-A402-16FD3190EF4B\"></a>The deformed shape node (pSphereShape) is shown on the right of the dependency graph.\n\
            The intermediate object (pSphereShapeOrig) is shown on the left of the dependency\n\
            graph. The intermediate object is at the head of each chain of deformers, but is not\n\
            displayed until you disable its intermediateObject attribute. The intermediate object\n\
            acts as storage for the original undeformed positions of the shape. \n\
         </p>\n\
         <p><a name=\"GUID-DD647D26-3881-4B39-A008-0C9F7C2F0DB0\"></a>In a typical deformer chain, shape data flows out of the intermediate object and then\n\
            flows through each of the deformers. In this example, the deformers that are traversed\n\
            are highlighted in yellow: tweak1, cluster1, and ffd1. Only a single shape flows through\n\
            ffd1. However, most deformers can operate on any number of shapes because the input\n\
            and output geometry attributes of the deformer base class are multis. The two exceptions\n\
            to this rule are the skinClusters and wrap node, which can operate on only a single\n\
            geometry. Additional geometries connected to the skinCluster and wrap node are ignored.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-3E244AC0-E830-4321-9440-E482835B891F\"></a>The dotted lines in the dependency graph indicate that some auxiliary nodes are not\n\
            displayed. In this example, the auxiliary nodes are the groupParts nodes, which are\n\
            used to store component lists for the deformer sets. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_6581C01634E14C9F82D74EE8457D2A98\"></a> \n\
            <h2><a name=\"GUID-A8E0B707-5F2F-4264-86AB-1CB804EE4E8A\"></a>Deformers and Sets\n\
            </h2> \n\
            <p><a name=\"GUID-00D12C82-0F0F-456A-9CF5-701E4F477B86\"></a>Each deformer is associated with a single set. It only deforms the points that are\n\
               included in the associated set. If you add points to a set using the sets command,\n\
               the deformer is automatically associated with the construction history of the shape.\n\
               Similarly, if you remove the points from a set, the deformer stops acting on the removed\n\
               points. The set used by the deformer is a vertex-restricted set that can only contain\n\
               vertices. The easiest way to find the associated set of a deformer is using the <span class=\"code\" translate=\"no\">MFnGeometryFilter::deformerSet</span> method. The returned set can then be used for creating an MFnSet, which can be used\n\
               to access the membership information. The following code snippet provides an example.\n\
               \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MFnGeometryFilter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_geometry_filter.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnGeometryFilter</a> fnDeformer(defObject);\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> setObject = fnDeformer.deformerSet();\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnSet\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_set.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnSet</a> fnSet(setObject);\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSelectionList</a> members;\n\
    fnSet.getMembers(members,false);\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItSelectionList</a> itr( members );\n\
    for (; !itr.isDone(); itr.next()) {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath</a> path;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> components;\n\
        itr.getDagPath(path, components);\n\
        …\n\
    }</pre></div> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_EBF87908A1AF4696956BC63CEC30D570\"></a> \n\
            <h2><a name=\"GUID-9D29CFCB-EEBD-4C3D-B01F-837D9252BB1A\"></a> GroupParts Node and GroupId Node\n\
            </h2> \n\
            <p><a name=\"GUID-528184A2-4026-481F-AA86-98AAE0D7D90D\"></a>Most sets in Maya consist of only the objectSet node. However, the component sets\n\
               in Maya are stored within the shape data rather than within the objectSet node. The\n\
               set is connected to a groupId node for each shape, and a groupParts node for each\n\
               shape with construction history. By default, Maya hides the groupParts and the groupId\n\
               nodes in the hypergraph because they clutter the view. You can turn on the display\n\
               of auxiliary nodes to view the groupParts and groupId nodes. The following figure\n\
               shows a hypergraph view of the groupParts, groupId, and objectSet nodes for an ffd\n\
               deformer. The tweak nodes are deleted from the shape\'s history to make the hypergraph\n\
               less cluttered. <a name=\"FIG_510AD67497D843CCAC3512165E74B51D\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-F1625874-523B-4867-BAB3-8CBBD5D78928-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-6878AB2C-7559-4BDC-A10B-C50E72135E23\"></a>The groupId node stores an ID that is unique in a scene for quickly determining the\n\
               membership of the set within the shape\'s list of sets. The groupParts node stores\n\
               the component sets for shapes with construction history. As the shape data flows through\n\
               the history, it might change its numbering. Component lists are stored using the vertex\n\
               index and some construction history nodes modify the vertex numbering, for example,\n\
               polySplit and deleteComponent. The groupParts node is not affected by the vertex numbering\n\
               changes because it is in the construction history. The groupPart node receives the\n\
               shape data before the vertices are renumbered. This architecture is useful in certain\n\
               poly-modeling operations. However, it can cause issues in the following scenarios:\n\
               <a name=\"UL_FDED8F1A567E410CB2EC319821194DCA\"></a><ul>\n\
                  <li>If you modify the construction history ahead of a groupParts node, your set might\n\
                     no longer contain reasonable indices. \n\
                  </li>\n\
                  <li>If you modify the topology after a groupParts node, it can become difficult to edit\n\
                     the earlier weights or other details in the dependency graph that rely on a different\n\
                     indexing scheme. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
            <p><a name=\"GUID-9BA6DAD4-777F-4B6E-BDA2-4A438A985851\"></a>For example, consider that you have created a 10 x 10 polyPlane with history. You\n\
               have selected the upper vertices in the plane, and then created a cluster. The cluster\n\
               acts on the selected vertices, which are contained in its set. Now, you select the\n\
               history node for the plane and modify the plane\'s number of divisions from 10 x 10\n\
               to 9 x 10. The membership of the cluster is now different than what you had originally\n\
               specified. The following figure illustrates this example. The membership of the cluster\n\
               that is created on a 10 x 10 plane is shown on the left and after the history is modified\n\
               to 9 x 10 is shown on the right. <a name=\"FIG_A4C2E3C2156F46F28A70B7230573E68A\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-83645E05-3433-4797-AD58-F2189F6891FD-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-F5354B32-4873-412D-879C-558DC1209F9F\"></a>If you have spent significant time weighting vertices, this can be very inconvenient.\n\
               To prevent this, you can follow a workaround, such as exporting the weight map before\n\
               changing the topology, and then importing the weight map. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";