var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-927AD891-F772-4FF2-B8FA-B711098E659B\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Locks</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-927AD891-F772-4FF2-B8FA-B711098E659B\"></a><div class=\"head\">\n\
            <h1>Locks</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F487557109353211EEADCAF73-710D\"></a>Locks are operators that define a region of code such that only a single thread can\n\
            traverse that code at any given time. Locks are also known as mutexes (mutual exclusions),\n\
            although that term can have slightly different meanings on different OS’s. A typical\n\
            example is to protect multiple simultaneous write operations to a global variable\n\
            from different threads. For example, if this code is called from multiple threads:\n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
static int val=0;\n\
LOCK;\n\
val++;\n\
UNLOCK;\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F487557109353211EEADCAF73-710C\"></a>and the lock were not in place, two threads could attempt to modify val at the same\n\
            time, both threads reading, updating and writing in separate stages, and so producing\n\
            incorrect results. This is known as a race condition, and is discussed in more detail\n\
            later.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F487557109353211EEADCAF73-710B\"></a>Locks may be recursive, so the same thread can acquire the same lock multiple times.\n\
            However this is generally considered to be a dangerous coding practice, as failure\n\
            to unlock an equal number of times can lead to hangs as the lock is never released.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F487557109353211EEADCAF73-710A\"></a>Managing locks correctly while avoiding race conditions is one of the most difficult\n\
            parts of threading.\n\
         </p>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7109\"></a> \n\
            <h2><a name=\"GUID-B476CC7C-DBEC-4F21-8C47-CB6EB74BD43A\"></a>Atomic operations\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7108\"></a>Modern processors are able to perform certain operations on variables atomically.\n\
               This means that the operation appears to be completed in a single step when viewed\n\
               from other threads of execution. As a result, such operations cannot cause race conditions\n\
               and do not require locking, as there is no possibility that another thread will be\n\
               able to read the value during the modification operation. On some operating systems,\n\
               low level functions are provided that directly invoke these atomic operations in hardware.\n\
               These operations are significantly faster than applying user locks, and should always\n\
               be used when possible.\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7107\"></a> \n\
            <h2><a name=\"GUID-2758058E-E3E5-4F88-9EB5-3DB081BA75D2\"></a>Semaphores and signals\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7106\"></a>A semaphore is a generalization of a mutex lock. Rather than the simple boolean state\n\
               of a mutex lock, a semaphore contains an internal counter. This counter is decremented\n\
               each time a thread asks the semaphore for access to the locked resource, and incremented\n\
               each time a thread releases the resource. If the counter reaches zero, additional\n\
               threads attempting to acquire the resource will block until one of the holding threads\n\
               releases the resource. So a semaphore with an initial value of 5 will allow at most\n\
               5 threads to access the resource simultaneously.\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7105\"></a> \n\
            <h2><a name=\"GUID-62865C84-F1CA-45C4-B1AB-AEE21953AD50\"></a>OSX platform-specific pthreads issues\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7104\"></a>Although the OSX pthreads implementation complies with the POSIX standard, it does\n\
               not include all the pthreads and associated functionality available on Linux. <span class=\"char_link\"><a href=\"#!/url=./files/GUID-EE052898-C59C-438A-9A77-798F5BEB7A77.htm\">Mac OS X platform specific pthreads issues</a></span> provides more details, and is important for anyone working directly with pthreads\n\
               on OSX. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7103\"></a> \n\
            <h2><a name=\"GUID-7D1CA075-B9CC-48AD-919A-FD892E3134FE\"></a>Native threads usage\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7102\"></a>These basic threading primitives are useful if you are working at a low level on a\n\
               single platform. They are complicated to use in cross-platform applications due to\n\
               the different implementations. They also require a lot of work compared with some\n\
               higher level threading implementations that will be described later. However for cases\n\
               where ultimate control over thread behavior is required, including operations such\n\
               as priority and affinity, native threads are the best option.\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";