var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-B200A5CA-9B08-4B99-ACB6-FE75770D1AC5\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Custom evaluator overview</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B200A5CA-9B08-4B99-ACB6-FE75770D1AC5\"></a><div class=\"head\">\n\
            <h1>Custom evaluator overview</h1>\n\
         </div><a name=\"FIG_8858F2ED5FDF4572BEB6AA6816B15D2D\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-57E9DA6F-DB97-48FB-859F-5FA7A7471DF8-low.png\"></div>\n\
         <p>This section explains API classes and methods used to add custom evaluators to Maya.\n\
            Custom evaluators let users override how DG nodes are scheduled and executed by the\n\
            evaluation manager. If you\'re unfamiliar with the scene evaluation changes introduced\n\
            in Maya 2016, see the \n\
            		<em class=\"mild\">Improving Performance with Parallel Evaluation</em> whitepaper at \n\
            		<a href=\"http://www.autodesk.com/maya-docs\" target=\"_blank\">http://www.autodesk.com/maya-docs</a> for a more detailed summary. \n\
            	 \n\
         </p>\n\
         <p>This section contains a brief review of how the evaluation manager builds, partitions,\n\
            and schedules the evaluation graph, followed by an introduction to new API classes,\n\
            and then closes with a simple example to motivate usage of new API classes; see the\n\
            devkit for additional examples. \n\
            	 \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_33C3514BFD06440CA67E10E981CD2034\"></a> \n\
            <h2><a name=\"GUID-50C8045E-76AF-4F3D-A898-4E2DF8AA591A\"></a>Introduction\n\
            </h2> \n\
            <p>The Evaluation Manager (EM), introduced in Maya 2016, improves playback and manipulation\n\
               performance by supporting concurrent evaluation of dependency graph (DG) nodes. \n\
               		\n\
            </p> \n\
            <p>The EM uses specialized evaluators to enable customized handling of different parts\n\
               of the scene. Maya 2016 includes 3 such evaluators: \n\
               		\n\
            </p> <a name=\"TABLE_893D6624CFC84C9595C86A5CA8368578\"></a><div class=\"table-ruled\">\n\
               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                  <colgroup>\n\
                     <col>\n\
                     <col>\n\
                  </colgroup>\n\
                  <tr class=\"ruled-heading\">\n\
                     <th class=\"table-heading\">Evaluator \n\
                        				  \n\
                     </th>\n\
                     <th class=\"table-heading\">Details \n\
                        				  \n\
                     </th>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\">Deformer \n\
                        				  \n\
                     </td>\n\
                     <td class=\"table-body\">Takes advantage of GPU hardware to deform dense geometry more quickly \n\
                        				  \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-even-row\">\n\
                     <td class=\"table-body\">Dynamics \n\
                        				  \n\
                     </td>\n\
                     <td class=\"table-body\">Detects if the scene contains unsupported legacy dynamics and disables parallel evaluation\n\
                        \n\
                        				  \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\">Prune Roots \n\
                        				  \n\
                     </td>\n\
                     <td class=\"table-body\">Groups animation curves during evaluation to reduce node-scheduling overhead \n\
                        				  \n\
                     </td>\n\
                  </tr>\n\
               </table>\n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_925881E2982946D3B312E1F324B6E500\"></a> \n\
               <h3><a name=\"GUID-EACB6E99-4960-4A2A-858D-99145C0E558B\"></a>Evaluation Manager Review\n\
               </h3> \n\
               <p>The EM performs 3 key steps when evaluating your scene: graph construction, graph\n\
                  partitioning, and graph scheduling, each described below. \n\
                  		  \n\
               </p> \n\
               <div class=\"section\"><a name=\"SECTION_4E46279B80C7414BA3F6D76638F8E999\"></a> \n\
                  <h4><a name=\"GUID-B883630B-418F-4272-999C-D3EF014E74EF\"></a>Graph Construction\n\
                  </h4> \n\
                  <p>Unlike classic Maya evaluation, the EM does not rely on dirty propagation to determine\n\
                     what to evaluate at every frame. Instead, the EM builds an evaluation graph (EG) that\n\
                     encodes dependencies between DG nodes. \n\
                     			 \n\
                  </p> \n\
                  <p>During EG construction, a list of plugs is built for each animated node. This list\n\
                     contains all plugs required by downstream dependents on a given node, guaranteeing\n\
                     that all upstream dependencies are up-to-date whenever a specific node is evaluated.\n\
                     \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"SECTION_476682CE0AD14FCBBF0661A60E24A8F7\"></a> \n\
                  <h4><a name=\"GUID-11544EE8-F5B6-46E8-88FE-902A60D143B7\"></a>Graph Partitioning\n\
                  </h4> \n\
                  <p>Once the EG is built, the EM must calculate how different parts of that graph will\n\
                     be evaluated. To do this, enabled evaluators are allowed to claim ownership for node\n\
                     sub-graphs, in priority order. To claim nodes, evaluators must mark nodes as being\n\
                     of interest. \n\
                     			 \n\
                  </p> \n\
                  <p>During traversal, any node-level cycles with 1 or more outputs connected to 1 or more\n\
                     inputs are grouped into \n\
                     				<em class=\"mild\">clusters</em> by the EM. Sub-graphs claimed by different evaluators are also added to clusters.\n\
                     \n\
                     			 \n\
                  </p> \n\
                  <p>Clusters are evaluated together as a single unit and are mutually exclusive (that\n\
                     is, an evaluation node can belong to one cluster at most). Hence, the set of all clusters\n\
                     provides a partitioning of the EG. \n\
                     			 \n\
                  </p> \n\
                  <p>Clusters are layered in a hierarchy such that if the current cluster fails to evaluate\n\
                     a node, control is passed to the parent cluster. In decreasing order of priority,\n\
                     cluster layers are: \n\
                     			 \n\
                  </p> <a name=\"TABLE_F0E7360AD0414327ACF22C44F1FBB019\"></a><div class=\"table-ruled\">\n\
                     <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                        <colgroup>\n\
                           <col>\n\
                           <col>\n\
                        </colgroup>\n\
                        <tr class=\"ruled-heading\">\n\
                           <th class=\"table-heading\">Layers \n\
                              						\n\
                           </th>\n\
                           <th class=\"table-heading\">Details \n\
                              						\n\
                           </th>\n\
                        </tr>\n\
                        <tr class=\"ruled-odd-row\">\n\
                           <td class=\"table-body\">Custom \n\
                              						\n\
                           </td>\n\
                           <td class=\"table-body\">Layer for custom evaluator clusters. Once a node is in a custom evaluator\'s cluster,\n\
                              that evaluator takes responsibility for its evaluation. \n\
                              						\n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-even-row\">\n\
                           <td class=\"table-body\">Cycle \n\
                              						\n\
                           </td>\n\
                           <td class=\"table-body\">Layer for DG node-level cycles (for example, constraints, and so on,) that often require\n\
                              special evaluation to ensure correctness. \n\
                              						\n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-odd-row\">\n\
                           <td class=\"table-body\">Base \n\
                              						\n\
                           </td>\n\
                           <td class=\"table-body\">The default, no cluster, layer. Nodes are evaluated directly without special treatment.\n\
                              \n\
                              						\n\
                           </td>\n\
                        </tr>\n\
                     </table>\n\
                  </div> \n\
                  <div><a name=\"GUID-BDA3FB43-9D01-4699-B806-E89E1ED8CFD4\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Clusters are created and destroyed during graph construction and scheduling. If the\n\
                        graph is invalidated, clusters will be destroyed. Custom evaluators should rely only\n\
                        upon cluster initialize and terminate callbacks and never cache pointers to the previous\n\
                        cluster. Currently, each cluster is represented and scheduled as a single unit, allowing\n\
                        custom evaluators to handle nodes as desired. \n\
                        			 \n\
                     </div>\n\
                  </div> \n\
               </div> \n\
               <div class=\"section\"><a name=\"SECTION_39C173D57F644A7381515A03F812FBF3\"></a> \n\
                  <h4><a name=\"GUID-926469E7-1879-4DE3-A492-206D272626F2\"></a>Graph Scheduling\n\
                  </h4> \n\
                  <p>After partitioning, the EM must schedule nodes for evaluation in the correct order.\n\
                     Nodes are scheduled so that upstream nodes are evaluated before all dependents. Beyond\n\
                     this, it\'s not possible to guarantee any particular order of evaluation. \n\
                     			 \n\
                  </p> \n\
                  <p>For example, in the simple graph, \n\
                     			 \n\
                  </p> <a name=\"FIG_83BC9E3962F04499B4C6EE8D7719479A\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-96341BED-C1B3-43C3-958E-4ECB600F156B-low.png\"></div> \n\
                  <p>node A always evaluates before B. For a more complex graph, \n\
                     			 \n\
                  </p> <a name=\"FIG_3FEA9F14D25C4A039C9F5B7A1F82B9A1\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-0716DEE4-BC7B-46D0-A829-7571894D9D8E-low.png\"></div> \n\
                  <p>although A is guaranteed to be evaluated before B and C, there are no guarantees about\n\
                     the exact timing of evaluation for B and C. Depending on the scheduling type of B\n\
                     and C, they could be evaluated simultaneously. \n\
                     			 \n\
                  </p> \n\
                  <div><a name=\"GUID-C6DBC439-627E-467D-ACA7-2580BFC1CC17\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If a node is frozen, even if scheduled, its evaluation is skipped. \n\
                        			 \n\
                     </div>\n\
                  </div> \n\
               </div> \n\
            </div> \n\
         </div><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-D353FAE7-4B6A-4EAD-9742-A6999CED11C2.htm\">Custom Evaluator API</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";