var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-D406310F-086C-4D33-8AF3-023692E7A50F\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>OpenMP</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D406310F-086C-4D33-8AF3-023692E7A50F\"></a><div class=\"head\">\n\
            <h1>OpenMP</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7100\"></a> \n\
            <h2><a name=\"GUID-0B1CEFDA-886F-4777-A0A8-B548F1C6F1CF\"></a>OpenMP overview\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FF\"></a>OpenMP is a higher level threading abstraction primarily designed for data parallelism\n\
               applied to \n\
               		  <em class=\"strong\">for</em> loops. It is supported by VS2005 and by the Intel compiler on all platforms. The\n\
               version of gcc required by Maya on OSX and Linux does not support OpenMP. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FE\"></a>OpenMP is implemented via compiler pragmas. Compared with native threading, it presents\n\
               a very simple interface to the user. All the thread creation and management and most\n\
               data partitioning is hidden from the user. OpenMP uses thread pools, which are created\n\
               the first time a parallel region is encountered (for this reason it is important to\n\
               ignore the very first threaded loop traversal in an application when profiling OpenMP\n\
               code.) \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FD\"></a>Here is a simple example of a threaded loop: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
#pragma omp parallel for\n\
for(int i=0; i&lt;imax; i++) {\n\
    doThreadsafeWork(i);\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FC\"></a>This code will be converted by the compiler into a function that is run in parallel\n\
               by multiple threads, by default one thread per logical processor. The first processor\n\
               takes the first (imax/numThreads) elements of the loop, the second processor takes\n\
               the next equally sized chunk and so on. This ensures good \n\
               		  <em class=\"strong\">cache affinity</em>, that is, the processor is usually working with adjacent data elements and so minimizes\n\
               cache misses. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FB\"></a>Here is a more complex example: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
#pragma omp parallel for schedule(guided) if(imax&gt;1000)\n\
for(int i=0; i&lt;imax; i++) {\n\
&nbsp;&nbsp;&nbsp;&nbsp;doThreadsafeWork(i);\n\
&nbsp;&nbsp;&nbsp;&nbsp;#pragma omp critical\n\
&nbsp;&nbsp;&nbsp;&nbsp;doNonThreadsafeWork(i);\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70FA\"></a>This code also breaks the loop into chunks, but the guided scheduling option causes\n\
               it to use chunks smaller than size (imax/numThreads), and to send a new chunk to each\n\
               thread as it finished an existing chunk. This provides better \n\
               		  <em class=\"strong\">load balancing</em> for cases where workload varies between iterations of the loop, since at runtime\n\
               additional chunks of work are assigned to any threads that finish early. The \n\
               		  <span class=\"code\" translate=\"no\">critical</span> pragma places a lock on the line which follows it. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70F9\"></a>The<span class=\"code\" translate=\"no\"> if</span> conditional on the main pragma causes the loop to be run in parallel only if the\n\
               trip count (number of loop iterations) exceeds the specified value. There is overhead\n\
               to invoking a parallel region, so it does not make sense to parallelize the evaluation\n\
               if the trip count is too low. A good rule of thumb is to assume an overhead of 10k\n\
               clock cycles to start and end a parallel region, so the cutoff trip count should try\n\
               to exceed this work. This is particularly important for an application like Maya,\n\
               where the same algorithm may be invoked on a single very dense object or a large number\n\
               of very simple objects. In the latter case, the extra startup overhead of thousands\n\
               of very short threaded evaluations could easily overwhelm any threading benefit, and\n\
               you might actually get significant slowdowns with threaded code that does not have\n\
               a cutoff. Note that even if the threading is not cut off by the conditional, the code\n\
               inside the loop is still extracted by the compiler into a separate function and will\n\
               take the hit of a function call. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70F8\"></a> \n\
            <h2><a name=\"GUID-C5CE05AD-6FA6-4AC8-9477-9FD557BD6465\"></a>Pros and cons of OpenMP\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70F7\"></a>The benefits of OpenMP are cross-platform support, simple implementation, and ease\n\
               of removal. Simply disabling the pragma causes the code to revert to its serial form,\n\
               and can be used as a quick way to check that the behavior is the same. A surprisingly\n\
               large amount of code can be threaded using very simple OpenMP pragmas such as those\n\
               in the examples above. It is very useful for quickly prototyping and evaluating possible\n\
               threading benefits, even if the final implementation will be done using a different\n\
               threading library. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70F6\"></a>The downsides are limited algorithm applicability, and incompatibility between implementations.\n\
               The VS2005 and Intel OpenMP libraries can be used together, but they do not recognize\n\
               each other\'s implementations. So a threaded loop compiled with VC2005 that calls a\n\
               function compiled with the Intel compiler will ignore any OpenMP locks defined by\n\
               the Intel compiler. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70F5\"></a>OpenMP is also problematical with nested threading, where higher level threads are\n\
               spawned that call into code that is itself threaded at a lower level. This causes\n\
               more threads to be activated than there are cores on the system. This is known as\n\
               \n\
               		  <em class=\"strong\">oversubscription</em>, and leads to poor performance. Oversubscription becomes increasingly problematical\n\
               as more threading is added to an application, since a developer may not even realize\n\
               that a function being called in parallel is itself threaded. \n\
               		\n\
            </p> \n\
            <p><em class=\"strong\">Oversubscription</em> is especially a problem during Evaluation Manager parallel evaluation. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70F4\"></a> \n\
            <h2><a name=\"GUID-91B6B5F9-0842-478C-B241-37E6CF1B1ED3\"></a>OpenMP and Maya spin-wait time\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70F3\"></a>Some algorithms in Maya are threaded using OpenMP, including the fluids and dynamics\n\
               solvers. Most data parallel loops use Intel® Threading Building Blocks (TBB), which\n\
               avoids issues when using the Evaluation Manager. See \n\
               		  <span class=\"char_link\"><a href=\"#!/url=./files/GUID-328D2310-7F66-4F35-8055-BB10D7B45D5F.htm\">Intel Threading Building Blocks</a></span>.\n\
               		\n\
            </p> \n\
            <p>Typically, the spin-wait time should be set to zero and not changed. If you are using\n\
               Intel OpenMP in a plug-in, and want to set a nonzero spin-wait time, you can include\n\
               the Intel compiler version of the header file \n\
               		  <span class=\"code\" translate=\"no\">omp.h</span> and then use the \n\
               		  <span class=\"code\" translate=\"no\">kmp_set_blocktime()</span> function.\n\
               		\n\
            </p> \n\
            <p>When doing this, be aware of potential race conditions between different plugins when\n\
               setting the block time during Evaluation Manager parallel evaluation. To avoid these\n\
               potential races, set the block time during plugin initialization and not during evaluation.\n\
               Also. be very careful to set the spin- wait time back to zero before exiting the plug-in\n\
               and returning control to Maya: \n\
               		  <span class=\"code\" translate=\"no\">kmp_set_blocktime(0);</span> \n\
            </p> \n\
            <p>Maya uses the Intel compiler for OpenMP on all platforms. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";