var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-F9186AE7-5CC7-4CB8-9756-5A302ADCE92C\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Overview of the Viewport 2.0 API</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F9186AE7-5CC7-4CB8-9756-5A302ADCE92C\"></a><div class=\"head\">\n\
            <h1>Overview of the Viewport 2.0 API</h1>\n\
         </div>\n\
         <p><a name=\"GUID-28A47730-0CB6-46D6-8ED8-619E9A8A8376\"></a> Maya 2012 introduced a new set of API classes for defining custom drawing, shading\n\
            and effects in both Viewport 2.0 and Hardware Renderer 2.0 (the new batch/render view\n\
            version of Viewport 2.0). \n\
         </p>\n\
         <p><a name=\"GUID-B6503A35-4776-4DAD-B74A-D1F8B47FD947\"></a>Maya’s Viewport 2.0 represents a brand-new rendering architecture in Maya that has\n\
            been written from the ground up to deliver high-performance on large scenes on top\n\
            of a programmable shader system offering high-quality per-pixel lighting and effects.\n\
            This, unfortunately, makes it incompatible with many of the existing Maya API classes,\n\
            due to their dependence on system memory geometry data, C++ driven rendering, and\n\
            high state switching overheads. As a result, most existing plug-ins will need to be\n\
            updated to support the new API classes in order to work correctly in Viewport 2.0.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-BC11741B-BF12-4DAB-8295-13C7B5122635\"></a>This section introduces the new classes and highlights the migration paths from the\n\
            old API to the new one. In most cases, it should be possible to write plug-in nodes\n\
            that simultaneously implement both the new and old APIs where required, thus maintaining\n\
            a single plug-in that will work in both viewports while artists, tools and pipelines\n\
            are migrated to Viewport 2.0. \n\
         </p>\n\
         <p><a name=\"GUID-7E0A266C-FAE2-4840-8AB6-E52D0A8165E2\"></a>This discussion of the new API is broken down into the following subsections: \n\
         </p><a name=\"UL_F020902C63B54FDFAF6AA6119324D583\"></a><ul>\n\
            <li><span class=\"char_link\"><a href=\"#!/url=./files/GUID-C16CA3BB-5BCA-473F-9025-8676AB3EF914.htm\">Data Classes</a></span> - the objects which describe and provide access to the geometry and shaders in the\n\
               scene. \n\
            </li>\n\
            <li><span class=\"char_link\"><a href=\"#!/url=./files/GUID-9496C634-9C18-49D4-A18C-D16600F73848.htm\">Scene Overrides</a></span> - the interfaces used to define custom drawing, shading and effects within the scene.\n\
               \n\
            </li>\n\
            <li><span class=\"char_link\"><a href=\"#!/url=./files/GUID-FBDD64EE-AD07-4EA2-A07A-D792B5B5DE0C.htm\">Rendering Overrides</a></span> - the objects used to define custom rendering, multi-pass effects, and filtering.\n\
               \n\
            </li>\n\
            <li><span class=\"char_link\"><a href=\"#!/url=./files/GUID-24BAA64A-DAEA-43DB-8FF0-5625F371AE67.htm\">Framework Classes</a></span> - the objects that provide services and device state information to plug-ins. \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"GUID-E03C2F74-BABE-4F4C-B737-D40E765E9A44\"></a>Following this, there are two subsections to help accelerate your transition to the\n\
            new API: \n\
         </p><a name=\"UL_187E31EE27E942FDACA0F6ED9A9AA54C\"></a><ul>\n\
            <li><span class=\"char_link\"><a href=\"#!/url=./files/GUID-7E935B18-FFBB-4DD3-82EA-A2175CF7795C.htm\">Transition Guide</a></span> - tips on moving from legacy interfaces to the new Viewport 2.0 API. \n\
            </li>\n\
            <li><span class=\"char_link\"><a href=\"#!/url=./files/GUID-9A5432D0-FA89-4E64-8277-22DC81680B20.htm\">Developer Kit Samples</a></span> - a brief overview of updated Developer Kit samples using the Viewport 2.0 API. \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"GUID-8BBAECF1-FFFB-48E5-8C48-EAB2FE332370\"></a></p>\n\
         <p><a name=\"GUID-9EDAB425-975A-4057-AA35-A7785060C668\"></a>All of the new classes reside in a new namespace within the Maya API called <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MHWRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_m_h_w_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender</a></span> (all references to class names in this document assume the namespace). This makes\n\
            it easy to locate all the classes related to viewport and batch hardware rendering\n\
            and also makes it easy to differentiate them from the older hardware API classes which\n\
            are not supported in Viewport 2.0 and Hardware Renderer 2.0. \n\
         </p><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-C16CA3BB-5BCA-473F-9025-8676AB3EF914.htm\">Data Classes</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-9496C634-9C18-49D4-A18C-D16600F73848.htm\">Scene Overrides</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-FBDD64EE-AD07-4EA2-A07A-D792B5B5DE0C.htm\">Rendering Overrides</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-24BAA64A-DAEA-43DB-8FF0-5625F371AE67.htm\">Framework Classes</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-7E935B18-FFBB-4DD3-82EA-A2175CF7795C.htm\">Transition Guide</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-9A5432D0-FA89-4E64-8277-22DC81680B20.htm\">Developer Kit Samples</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";