var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-FF4FEEE5-3D20-4259-9AF0-D2DBE867679B\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Sharing common functions between shader stages in OGSFX</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FF4FEEE5-3D20-4259-9AF0-D2DBE867679B\"></a><div class=\"head\">\n\
            <h1>Sharing common functions between shader stages in OGSFX</h1>\n\
         </div>\n\
         <p><a name=\"GUID-E3BEBDF6-57FA-444D-90B9-C62B0A133408\"></a>As seen in \n\
            		<span class=\"char_link\"><a href=\"#!/url=./files/GUID-94505429-12F9-4F04-A4D9-B80880AD0BA1.htm\">Convert existing GLSL shaders to OGSFX format</a></span>, each shader stage has its own GLSLShader \n\
            		<em class=\"mild\">block</em> that contains the function that it uses. \n\
            	 \n\
         </p>\n\
         <p><a name=\"GUID-E82BA64C-FAAA-4985-B5E8-25E576448CEA\"></a>The following examples demonstrate how to write your code so that two stages can use\n\
            the same functions. \n\
            	 \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_DD39B399FC8E495189918C06EDCDEA3A\"></a> \n\
            <h2><a name=\"GUID-DA987C1C-9106-42A4-8D5D-3CE51FFC5FA5\"></a>Duplicated functions in a .ogsfx file\n\
            </h2> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">// World-view-projection transformation.\n\
uniform mat4 gWVPXf : WorldViewProjection;\n\
\n\
attribute vs_input\n\
{\n\
    vec3 in_position : POSITION;\n\
};\n\
 \n\
attribute vs_to_ps\n\
{\n\
    // None\n\
};\n\
 \n\
attribute ps_output \n\
{\n\
    vec4 out_color : COLOR0;\n\
}\n\
 \n\
GLSLShader VS\n\
{\n\
    vec4 convertVec3ToVec4(vec3 input)\n\
    {\n\
        return vec4(input, 1);\n\
    }\n\
 \n\
    void main() \n\
    {\n\
        gl_Position = gWVPXf*convertVec3ToVec4(in_position);\n\
    }\n\
}\n\
 \n\
GLSLShader PS1\n\
{\n\
    vec4 convertVec3ToVec4(vec3 input)\n\
    {\n\
        return vec4(input, 1);\n\
    }\n\
 \n\
    vec4 computeTransparency(vec3 color3)\n\
    {\n\
        vec4 color4 = convertVec3ToVec4(color3);\n\
         \n\
        float alpha = 1;\n\
        // ... perform a number of calculations\n\
        color4.w = alpha;\n\
 \n\
        return color4;\n\
    }\n\
 \n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(1, 0, 0));\n\
    }\n\
}\n\
 \n\
GLSLShader PS2\n\
{\n\
    vec4 convertVec3ToVec4(vec3 input)\n\
    {\n\
        return vec4(input, 1);\n\
    }\n\
 \n\
    vec4 computeTransparency(vec3 color3)\n\
    {\n\
        vec4 color4 = convertVec3ToVec4(color3);\n\
 \n\
        float alpha = 1;\n\
        // ... perform a number of calculations\n\
        color4.w = alpha;\n\
 \n\
        return color4;\n\
    }\n\
 \n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(0, 1, 0));\n\
    }\n\
}\n\
  \n\
technique Main\n\
{\n\
    pass p1\n\
    {\n\
        VertexShader (in vs_input, out vs_to_ps) = VS;\n\
        PixelShader (in vs_to_ps, out ps_output) = PS1;\n\
    }\n\
 \n\
    pass p2\n\
    {\n\
        VertexShader (in vs_input, out vs_to_ps) = VS;\n\
        PixelShader (in vs_to_ps, out ps_output) = PS2;\n\
    }\n\
}</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_54503E0A87514C7A87E1F1EB9180C4B3\"></a> \n\
            <h2><a name=\"GUID-34588C84-4747-45A4-90B8-C6C106C17D7F\"></a>Implicitly shared functions in a .ogsfx file\n\
            </h2> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">// World-view-projection transformation.\n\
uniform mat4 gWVPXf : WorldViewProjection;\n\
\n\
attribute vs_input\n\
{\n\
    vec3 in_position : POSITION;\n\
};\n\
 \n\
attribute vs_to_ps\n\
{\n\
    // None\n\
};\n\
 \n\
attribute ps_output \n\
{\n\
    vec4 out_color : COLOR0;\n\
}\n\
 \n\
// Declare the functions that can be shared among all the shader stages\n\
GLSLShader Common_Functions\n\
{\n\
    vec4 convertVec3ToVec4(vec3 input)\n\
    {\n\
        return vec4(input, 1);\n\
    }\n\
}\n\
  \n\
// Declare the functions that can be shared among the pixel shader stages\n\
GLSLShader Common_Pixel_Functions\n\
{\n\
    vec4 computeTransparency(vec3 color3)\n\
    {\n\
        vec4 color4 = convertVec3ToVec4(color3);\n\
 \n\
        float alpha = 1;\n\
        // ... perform a number of calculations\n\
        color4.w = alpha;\n\
 \n\
        return color4;\n\
    }\n\
}\n\
 \n\
GLSLShader VS\n\
{\n\
    void main() \n\
    {\n\
        gl_Position = gWVPXf*convertVec3ToVec4(in_position);\n\
    }\n\
}\n\
 \n\
GLSLShader PS1\n\
{\n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(1, 0, 0));\n\
    }\n\
}\n\
 \n\
GLSLShader PS2\n\
{\n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(0, 1, 0));\n\
    }\n\
}\n\
  \n\
technique Main\n\
{\n\
    pass p1\n\
    {\n\
        // Declare the vertex shader stage to include the functions\n\
        // from the VS GLSLShader block.\n\
        // The stage will also include all the functions\n\
        // from blocks that do not contain a main().\n\
        // The vertex shader stage will then contain functions from\n\
        // Common_Functions, Common_Pixel_Functions and VS.\n\
        VertexShader (in vs_input, out vs_to_ps) = VS;\n\
 \n\
        // The pixel shader stage will contain functions from\n\
        // Common_Functions, Common_Pixel_Functions and PS1.\n\
        PixelShader (in vs_to_ps, out ps_output) = PS1;\n\
    }\n\
 \n\
    pass p2\n\
    {\n\
        VertexShader (in vs_input, out vs_to_ps) = VS;\n\
        PixelShader (in vs_to_ps, out ps_output) = PS2;\n\
    }\n\
}</pre></div> \n\
            <div><a name=\"GUID-B94430C5-E150-42AF-8F40-8160DB8D59A8\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n\
                  <p><a name=\"GUID-D6C801BA-770F-4EA0-BB48-48D702408871\"></a>Implicitly shared blocks may add overhead to the shader compiler: for example, \n\
                     			 <span class=\"code\" translate=\"no\">computeTransparency</span> will be processed by the vertex shader even though it is not used. Also, the compilation\n\
                     may fail because not all GLSL built-in functions/keywords are available for all shader\n\
                     stages; for example, \n\
                     			 <span class=\"code\" translate=\"no\">discard</span> is only available in the pixel shader stage and will fail for a vertex shader. It\n\
                     is, however, possible to only enable a section of code during a specified shader stage\n\
                     by using preprocessor directives. See \n\
                     			 <span class=\"char_link\"><a href=\"#!/url=./files/GUID-A8FFDD5C-EBC0-4FAA-84EF-EFA68053B13E.htm#SECTION_007AC660359B4BBFA571025952DCF79C\">OGSFX preprocessor directives</a></span>. \n\
                     		  \n\
                  </p> \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_92A006D2919446D6A9EF8BBFE7CF018E\"></a> \n\
            <h2><a name=\"GUID-93F6A0F6-651D-4330-A095-3C2403EA4EEC\"></a>Explicitly shared functions in a .ogsfx file\n\
            </h2> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">// World-view-projection transformation.\n\
uniform mat4 gWVPXf : WorldViewProjection;\n\
\n\
attribute vs_input\n\
{\n\
    vec3 in_position : POSITION;\n\
};\n\
 \n\
attribute vs_to_ps\n\
{\n\
    // None\n\
};\n\
 \n\
attribute ps_output \n\
{\n\
    vec4 out_color : COLOR0;\n\
}\n\
 \n\
// Declare the functions that can be shared among all the stages\n\
GLSLShader Common_Functions\n\
{\n\
    vec4 convertVec3ToVec4(vec3 input)\n\
    {\n\
        return vec4(input, 1);\n\
    }\n\
}\n\
 \n\
// Declare the functions that can be shared among the pixel shader stages\n\
GLSLShader Common_Pixel_Functions\n\
{\n\
    vec4 computeTransparency(vec3 color3)\n\
    {\n\
        vec4 color4 = convertVec3ToVec4(color3);\n\
 \n\
        float alpha = 1;\n\
        // ... perform a number of calculations\n\
        color4.w = alpha;\n\
 \n\
        return color4;\n\
    }\n\
}\n\
 \n\
GLSLShader VS\n\
{\n\
    void main() \n\
    {\n\
        gl_Position = gWVPXf*convertVec3ToVec4(in_position);\n\
    }\n\
}\n\
 \n\
GLSLShader PS1\n\
{\n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(1, 0, 0));\n\
    }\n\
}\n\
 \n\
GLSLShader PS2\n\
{\n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(0, 1, 0));\n\
    }\n\
}\n\
  \n\
technique Main\n\
{\n\
    pass p1\n\
    {\n\
        // Declare the vertex shader stage to include ONLY the functions\n\
        // from the Common_Functions and VS GLSLShader blocks\n\
        // Note that the order is important as each block will only \'know\'\n\
        // the functions that have been included in previous blocks\n\
        VertexShader (in vs_input, out vs_to_ps) = { Common_Functions, VS };\n\
 \n\
        // Declare the vertex shader stage to include ONLY the functions\n\
        // from Common_Functions, Common_Pixel_Functions and PS1\n\
        PixelShader (in vs_to_ps, out ps_output) = { Common_Functions, Common_Pixel_Functions, PS1 };\n\
    }\n\
 \n\
    pass p2\n\
    {\n\
        VertexShader (in vs_input, out vs_to_ps) = { Common_Functions, VS };\n\
        PixelShader (in vs_to_ps, out ps_output) = { Common_Functions, Common_Pixel_Functions, PS2 };\n\
    }\n\
}</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";