var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-05-12\">\n\
      <meta name=\"topicid\" content=\"GUID-DD12B62A-57EF-4588-A303-2EFDB00096FD\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Using a debugger to debug your plug-ins</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DD12B62A-57EF-4588-A303-2EFDB00096FD\"></a><div class=\"head\">\n\
            <h1>Using a debugger to debug your plug-ins</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-1D9\"></a>To start Maya under the control of a debugger, you use the \"-d\" flag of the <span class=\"code\" translate=\"no\">maya</span> shell script. The syntax for this is: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
maya -d debuggerName\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-1D8\"></a>or, for example: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
maya -d ddd\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-1D7\"></a>This launches the debugger given as an argument to the -d, and then starts Maya under\n\
            control of this debugger. Once you have started Maya and loaded your plug-in, you\n\
            can: \n\
         </p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-1D6\"></a><ul>\n\
            <li>set breakpoints in the plug-in code </li>\n\
            <li>single step through the plug-in </li>\n\
            <li>perform any of the operations supported by the debugger </li>\n\
         </ul>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-1D2\"></a>By default, Maya catches several signals generated by programming faults, in particular:\n\
            SIGSEGV, SIGILL, SIGBUS and SIGABRT. When debugging a plug-in with a debugger, it\n\
            is likely that you will want to suppress this behavior of Maya, and instead let the\n\
            debugger catch the signals. This can be accomplished by setting an environment variable,\n\
            as shown below: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
setenv MAYA_DEBUG_NO_SIGNAL_HANDLERS 1\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-1D1\"></a>This variable can be set either in the environment or the Maya.env file. If you use\n\
            cvd as your debugger, beware of a potential conflict. The Maya shell script sets the\n\
            values of two environment variables that tell the Maya binary where to find things.\n\
            These variables are: \n\
         </p><a name=\"WS17956D7ADBC6E7366D5C9783117AE330779-7FF9\"></a><ul>\n\
            <li>MAYA_LOCATION </li>\n\
            <li>LD_LIBRARY_PATH </li>\n\
         </ul>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-1CE\"></a>If you have set either of these in your shell’s start-up file (.cshrc or.profile),\n\
            you must protect them so shells started by the debugger (after the Maya shell script\n\
            has started that debugger) do not undo these modifications. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-1CD\"></a>If you use csh or tcsh use the following construct: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
if ( ! ${?MAYA_LOCATION} )\n\
    setenv MAYA_LOCATION /usr/autodesk/maya2016-x64\n\
if ( ! ${?LD_LIBRARY_PATH} )\n\
    setenv LD_LIBRARY_PATH whatEver\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-1CC\"></a>and if you use sh or ksh use this construct: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
MAYA_LOCATION=${MAYA_LOCATION:=/usr/autodesk/maya2016-x64}\n\
export MAYA_LOCATION\n\
LD_LIBRARY_PATH=${LD_LIBRARY_PATH:=whatEver}\n\
export LD_LIBRARY_PATH\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-1CB\"></a></p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";